#!/bin/csh
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

if ("$1" == "") then
        set dir="intel64"
else if ("$1" != "intel64") then
    echo "ERROR: Unknown switch '$1'. Accepted value is 'intel64'."
    exit 1
else
    set dir="$1"
endif

#Get path to script
set DIR=`ls -l /proc/$$/fd | grep -oE /.\*clckvars\.csh`
#Get path to the root directory for this install, is in a parent directory from this script
set DIR=`echo $DIR | sed 's_\(bin\).*_\1_'`
set DIR=`dirname "$DIR"`
setenv CLCK_ROOT $DIR

#Set up PATH variables using root directory for this install
if !($?PATH) then
    setenv PATH $CLCK_ROOT/bin/${dir}
else
    setenv PATH $CLCK_ROOT/bin/${dir}:${PATH}
endif

if !($?LIBRARY_PATH) then
    setenv LIBRARY_PATH $CLCK_ROOT/lib/${dir}
else
    setenv LIBRARY_PATH $CLCK_ROOT/lib/${dir}:${LIBRARY_PATH}
endif

if !($?CPLUS_INCLUDE_PATH) then
    setenv CPLUS_INCLUDE_PATH $CLCK_ROOT/include
else
    setenv CPLUS_INCLUDE_PATH $CLCK_ROOT/include:${CPLUS_INCLUDE_PATH}
endif

if !($?INTEL_LICENSE_FILE) then
   setenv INTEL_LICENSE_FILE "$CLCK_ROOT/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"
else
   setenv INTEL_LICENSE_FILE "${INTEL_LICENSE_FILE}:$CLCK_ROOT/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"
endif

if !($?MANPATH) then
    setenv MANPATH $CLCK_ROOT/man
else
    setenv MANPATH $CLCK_ROOT/man:${MANPATH}
endif
