#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

#Get path to script
DIR="${BASH_SOURCE[0]}"

if [ -z "$1" ]; then
        dir="intel64"

else
    if [ "$1" != "intel64" ]; then
        echo "ERROR: Unknown switch '$1'. Accepted value is 'intel64'."
        return 1;
    fi
    dir="$1"
fi

#Get full path to script
DIR="$( cd -P "$( dirname "$DIR" )" && pwd)"
#Get path to clck_root (which is a parent dir of this script)
DIR="$(echo $DIR | sed 's_\(bin\).*_\1_')"
DIR="$(dirname "$DIR")"

CLCK_ROOT="$DIR"
export CLCK_ROOT


#Set up PATH variables using root directory for this install
if [ -z "${PATH}" ]
then
    PATH=${CLCK_ROOT}/bin/${dir}
else
    PATH=${CLCK_ROOT}/bin/${dir}:${PATH}
fi
export PATH

if [ -z "${LIBRARY_PATH}" ]
then
    LIBRARY_PATH=${CLCK_ROOT}/lib/${dir}
else
    LIBRARY_PATH=${CLCK_ROOT}/lib/${dir}:${LIBRARY_PATH}
fi
export LIBRARY_PATH

if [ -z "${CPLUS_INCLUDE_PATH}" ]
then
    CPLUS_INCLUDE_PATH=${CLCK_ROOT}/include
else
    CPLUS_INCLUDE_PATH=${CLCK_ROOT}/include:${CPLUS_INCLUDE_PATH}
fi
export CPLUS_INCLUDE_PATH

if [ -z "${INTEL_LICENSE_FILE}" ]
then
    INTEL_LICENSE_FILE="${CLCK_ROOT}/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"; export INTEL_LICENSE_FILE
else
    INTEL_LICENSE_FILE="${INTEL_LICENSE_FILE}:${CLCK_ROOT}/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"; export INTEL_LICENSE_FILE
fi

if [ -z "${MANPATH}" ]
then
    MANPATH=${CLCK_ROOT}/man
else
    MANPATH=${CLCK_ROOT}/man:${MANPATH}
fi
export MANPATH
