/*
 * Copyright 2018-2019 Intel Corporation
 *
 * This software and the related documents are Intel copyrighted materials, and
 * your use of them is governed by the express license under which they were
 * provided to you (License). Unless the License provides otherwise, you may
 * not use, modify, copy, publish, distribute, disclose, or transmit this
 * software or the related documents without Intel's prior written permission.
 *
 * This software and the related documents are provided as is, with no express
 * or implied warranties, other than those that are expressly stated in the
 * License.
 */

#ifndef __ANALYZER_CONFIG_DOT_H__
#define __ANALYZER_CONFIG_DOT_H__

#include <map>
#include <string>
#include <unordered_map>
#include <vector>

#include "datastore_defines.h"

using clck::datastore::Row;
using clck::datastore::Rows;

namespace clck {

using ProviderRows = std::unordered_map<std::string, std::vector<clck::datastore::Row>>;
// Capture Missing Provider Data for the hosts
// Key: Provider, Value: Hostnames
using MissingData = std::map<std::string, std::set<std::string>>;
// Capture Old Provider Data list for the hosts
// Key: Provider, Value: Hostnames
using OldData = std::map<std::string, std::set<std::string>>;

}

#endif  // __ANALYZER_CONFIG_DOT_H__
