 ; Copyright 2018-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass BIOS_CHECKER
  "This class represents bios settings we get through reading MSRs."
  (is-a BASE_NODE TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot hwp_epp (type NUMBER)) ; Intel(R) Speed Shift Technology enabled
  (slot hwp_epp-string (type STRING)) ; Intel(R) Speed Shift Technology enabled
  (slot hwp_native-compliant (type NUMBER)) ; Intel(R) Speed Shift Technology in native compliant state
  (slot hwp_native-compliant-string (type STRING)) ; Intel(R) Speed Shift Technology in native compliant state
  (multislot hwp_native-compliant-cpus (type STRING))
  (multislot hwp_native-non-compliant-cpus (type STRING))
  (slot turbo-compliant (type NUMBER)) ; Intel(R) Turbo Boost Technology enabled
  (slot turbo-compliant-string (type STRING)) ; Intel(R) Turbo Boost Technology enabled
  (slot epb-compliant (type NUMBER)) ; Energy/Performance Balance is balanced
  (slot epb-compliant-string (type STRING)) ; Energy/Performance Balance is balanced
  (multislot epb-compliant-cpus (type STRING))
  (multislot epb-non-compliant-cpus (type STRING))
)





