 ; Copyright 2017-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass FILES
  "This class represents the present state of a specific file relative to an
   initial stable state."
  (is-a BASE_NODE BASE_TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot file  (type STRING))
  (slot permission_ref  (type STRING))
  (slot owner_ref  (type STRING))
  (slot group_ref  (type STRING))
  (slot md5sum_ref (type STRING))
  (slot permission_test  (type STRING))
  (slot owner_test  (type STRING))
  (slot group_test  (type STRING))
  (slot md5sum_test (type STRING))
  ;1 for permission, 2 for owner, 3 for group, 4 for md5sum
  (slot attribute (type INTEGER) (allowed-values 1 2 3 4))
  (slot status (type SYMBOL) (allowed-values extra missing modified))

)
