 ; Copyright 2018-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass LAYER
  "This class represents the data collected from the version file.
   Instances of the class are created, and the data slots are populated,
   by the analyze extension component."
  (is-a BASE_NODE TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (multislot layer (type STRING)) ; Found layers
  (slot stderr (type STRING))) ; STDERR string

(defclass SSF
  "Layers found in the file ssf-release"
  (is-a LAYER))

(defclass INTEL_HPC_PLATFORM_VERSION
  "Layers found in the file intel-hpc-platform-release"
  (is-a LAYER))
