 ; Copyright 2006-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass PROCESS
  "This class represents the data collected from the ps system
   utility.  The slot names roughly match the ps fields.  Instances of
   this class are created, and the data slots populated, by the
   analyze extension component."
  (is-a BASE_NODE TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot cmd (type STRING) (default ?NONE))            ; command name
  (slot etime (type NUMBER) (default 0))              ; elapsed time
  (slot pcpu (type NUMBER) (default 0) (range 0 100)) ; percent cpu
  (slot pid (type INTEGER) (default ?NONE))           ; process id
  (slot pmem (type NUMBER) (default 0) (range 0 100)) ; percent memory
  (slot state (type STRING) (default ?NONE))          ; process state
  (slot uid (type INTEGER) (default ?NONE))           ; user id
  (slot username (type STRING) (default ?NONE)))      ; user
