 ; Copyright 2016-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass RPM_BASELINE
  "RPM class used to store the rpm's that are installed on the nodes.
   For every node and every rpm there should be one defclass that
   indicates if the rpm is installed or not."
  (is-a BASE_NODE BASE_TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot rpm_name  (type STRING));rpm baseline name
  (slot rpm_version  (type STRING) (default "")); rpm baseline v
  (slot rpm_release  (type STRING) (default "")); rpm baseline rel
  (slot rpm_arch  (type STRING) (default "")); rpm baseline arch
  (slot rpm_version_test  (type STRING)(default "")); rpm test v
  (slot rpm_release_test  (type STRING)(default "")); rpm test rel
  (slot rpm_arch_test  (type STRING)(default "")); rpm test arch
  (slot status (type SYMBOL) (allowed-values extra missing modified missing_node extra_node))

  )

