 ; Copyright 2018-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.


(defclass SDVIS-TOOL-SET
  (is-a BASE_NODE BASE_TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  ; This slot holds the name of the tool
  (multislot toolnames (type SYMBOL))

  ; This slot holds the tool's version  if applicable
  (multislot versions (type SYMBOL))

  ; This slot holds the stdout of a command run with the tool. It
  ; could be the output of running the command itself or it could be
  ; the output of running a script with the command etc
  (multislot stdouts (type STRING))

  ; This slot holds the stderr of a command run with the tool. It
  ; could be the standard error seen when running the command itself
  ; or it could be the standard error when running a script with the
  ; command etc.
  (multislot stderrs (type STRING))

  (multislot req-tools (storage shared) (type SYMBOL) (access read-only)
            (default (create$ pvserver mesa vtk)))

  (multislot req-versions (storage shared) (type SYMBOL) (access read-only)
            (default (create$ 5.5.0 18.1.0 8.1.1))))

  (defmessage-handler SDVIS-TOOL-SET get-req-version (?tool)
    (bind ?i (member$ ?tool ?self:req-tools))
    (return (nth$ ?i ?self:req-versions)))

  (defmessage-handler SDVIS-TOOL-SET get-version (?tool)
    (bind ?i (member$ ?tool ?self:toolnames))
    (return (nth$ ?i ?self:versions)))

  (defmessage-handler SDVIS-TOOL-SET get-stdout (?tool)
    (bind ?i (member$ ?tool ?self:toolnames))
    (return (nth$ ?i ?self:stdouts)))

  (defmessage-handler SDVIS-TOOL-SET get-stderr (?tool)
    (bind ?i (member$ ?tool ?self:toolnames))
    (return (nth$ ?i ?self:stderrs)))
