 ; Copyright 2018-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass SYSCTL_STATUS
  (is-a BASE_NODE BASE_TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (multislot service-names (type SYMBOL))
  (multislot load-statuses (type SYMBOL))
  (multislot active-states (type SYMBOL))
  (multislot sub-states (type SYMBOL))
  (multislot descriptions (type STRING)))

(defmessage-handler SYSCTL_STATUS get-load-state (?param)
  (bind ?i (member$ ?param ?self:service-names))
  (return (nth$ ?i ?self:load-statuses)))

(defmessage-handler SYSCTL_STATUS get-active-state (?param)
  (bind ?i (member$ ?param ?self:service-names))
  (return (nth$ ?i ?self:active-states)))

(defmessage-handler SYSCTL_STATUS get-sub-state (?param)
  (bind ?i (member$ ?param ?self:service-names))
  (return (nth$ ?i ?self:sub-states)))

(defmessage-handler SYSCTL_STATUS get-description (?param)
  (bind ?i (member$ ?param ?self:service-names))
  (return (nth$ ?i ?self:descriptions)))

(defmessage-handler SYSCTL_STATUS lookup-key (?param)
  (bind ?role other)
  (if (member$ compute ?self:role) then (bind ?role compute))
  (if (member$ enhanced ?self:role) then (bind ?role enhanced))
  (bind ?key (sym-cat (class ?self) - ?self:subcluster - ?self:architecture +
                      ?role + ?param))
  (return ?key))
