 ; Copyright 2006-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(defclass BASE_NODE
  "Fundamental base class for nodes.  This class should be inherited
   by all classes that need the base characteristics of a node, such
   as a unique node identifier."
  (is-a USER)
  (role abstract)

  (slot architecture (type SYMBOL) (allowed-symbols i686 k1om x86_64)
        (default x86_64) (visibility public))
  (multislot role (type SYMBOL) (visibility public) (default compute))
  (slot node_id (type SYMBOL) (visibility public))
  (slot subcluster (type SYMBOL) (visibility public) (default default)))

(defclass NODE
  "The core class for nodes.  This class describes the hardware and
   software that comprises a node."
  (is-a BASE_NODE)
  (role concrete)
  (pattern-match reactive))

