; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule adjust-thresholds
  (declare (salience 10000))
   ?obj <- (object (is-a CONFIG) (name [config])
              (hpcg-single-perf-threshold 32.0)
              (hpcg-4node-perf-threshold 126.9)
              (dgemm-perf-threshold 2048)
              (hpl-4node-perf-threshold 8050)
              (stream-perf-threshold 164000)
              (imb_pingpong-bandwidth-perf-threshold 11300)
              (imb_pingpong-latency-perf-threshold 1.9)
           )
   =>
   (modify-instance ?obj
      ; The performance threshold that a single node HPCG has to meet
      (hpcg-single-perf-threshold 32.0)
      ; The performance threshold that a multinode HPCG has to meet
      (hpcg-4node-perf-threshold 127.0)
      ; The performance threshold that a single node DGEMM has to meet
      (dgemm-perf-threshold 2048)
      ; The performance threshold that a multinode node HPL has to meet
      (hpl-4node-perf-threshold 7700)
      ; The performance threshold that STREAM Triad has to meet
      (stream-perf-threshold 164000)
      ; The performance threshold that the IMB pingpong bandwidth has to meet
      (imb_pingpong-bandwidth-perf-threshold 11300)
      ; The performance threshold that the IMB pingpong latency has to meet
      (imb_pingpong-latency-perf-threshold 1.8)
   )
)
