 ; Copyright 2018-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(deffunction cat-node-name-of ($?vector)
  "Return a string concatenation of the elements in the multislot"
  (bind ?cat "")
  (foreach ?v $?vector
    (bind ?name (send ?v get-node_id)) 
    (if (neq (str-compare ?cat "") 0)
      then (bind ?cat (str-cat ?cat ", ")))
    (bind ?cat (str-cat ?cat ?name)))
  (return ?cat)
)

(deffunction is-compute ($?roles)
  "Return true if the role includes compute or enhanced, false if not"
    (if (member$ compute ?roles)
      then (return TRUE))
    (if (member$ enhanced ?roles)
      then (return TRUE))
  (return FALSE)
)
