 ; Copyright 2018-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(deffunction number-of ($?vector)
  "Return the number of the elements in the multislot"
  (return (length$ ?vector))
)

(deffunction cat-number-of ($?vector)
  "Return a string concatenation of the elements in the multislot"
  (bind ?cat "")
  (foreach ?v $?vector
    (if (neq (str-compare ?cat "") 0)
      then (bind ?cat (str-cat ?cat ", ")))
    (bind ?cat (str-cat ?cat ?v)))
  (return ?cat)
)

(deffunction number-eq-type (?type $?vector)
  "Return the number of the type specified in a multislot"
  (bind ?number 0)
  (foreach ?v $?vector
    (if (eq (str-compare ?v ?type) 0)
      then (bind ?number (+ ?number 1))))
  (return ?number)
)

(deffunction number-of-type (?operator ?type $?vector)
  "Return the number of the type specified in a multislot"
  (bind ?number 0)
  (foreach ?v $?vector
    (if (test-parameters ?v ?type ?operator)
      then (bind ?number (+ ?number 1))))
  (return ?number)
)

(deffunction number-eq-type-vector (?type $?vector)
  "Return the number of the type specified in a multislot"
  (bind ?number 0)
  (bind ?indexs (create$ ))
  (foreach ?v $?vector
    (bind ?number (+ ?number 1))
    (if (eq (str-compare ?v ?type) 0)
      then (bind ?indexs (create$ ?indexs ?number))))
  (return ?indexs)
)

(deffunction number-of-type-vector (?operator ?type $?vector)
  "Return the number of the type specified in a multislot"
  (bind ?number 0)
  (bind ?indexs (create$ ))
  (foreach ?v $?vector
    (bind ?number (+ ?number 1))
    (if (test-parameters ?v ?type ?operator)
      then (bind ?indexs (create$ ?indexs ?number))))
  (return ?indexs)
)

