; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.


(deffunction test_condition (?val ?shift ?output-shift)
  (if (< ?output-shift 1) then
     (if (> ?val 1024.0) then
       (return TRUE)
     )
   else
     (if (< ?shift ?output-shift) then
        (return TRUE)
     )
  )
 (return FALSE)
)

(deffunction perform_byte_conversion (?input-value ?precision ?output-shift)
"
This function takes in the input value in bytes and converts them to nearest
unit resulting in result less than 1024. The function returns rounds to nearest
number with decimal precision of 1.
"
(if (< ?precision 0)
  then
  (bind ?precision 0)
)
; default shift is null shift
(bind ?shift 0)
(if (> ?output-shift 0) then
  (if (>= ?output-shift 8) then
    (bind ?output-shift 8)
  )
  else
    ; negative shift not allowed
    (bind ?output-shift 0)
)
; default reporting unit is byte (B)
(bind ?unit "B")
(bind ?calc-value ?input-value)
; goal is to bring the display value within 1024 (2^10)
; or attain the requested range
(while (test_condition ?calc-value ?shift ?output-shift)
  (bind ?calc-value (/ ?calc-value 1024.0))
  (bind ?shift (+ ?shift 1))
)
; looping and reduction done, depending on the number of shifts append
; the units
(switch ?shift
   (case 1 then
      (bind ?unit "KiB")
   )
   (case 2 then
      (bind ?unit "MiB")
   )
   (case 3 then
      (bind ?unit "GiB")
   )
   (case 4 then
      (bind ?unit "TiB")
   )
   (case 5 then
      (bind ?unit "PiB")
   )
   (case 6 then
      (bind ?unit "EiB")
   )
   (case 7 then
      (bind ?unit "ZiB")
   )
   (case 8 then
      (bind ?unit "YiB")
   )
)
; create the formating string
(bind ?pstring (str-cat "%." ?precision "f"))
; apply the right number for precisions
(bind ?calc-value (format nil ?pstring ?calc-value))
; return the value with units
(bind ?rval (str-cat ?calc-value " " ?unit))
(return ?rval))
