 ; Copyright 2006-2019 Intel Corporation
 ;
 ; This software and the related documents are Intel copyrighted materials, and
 ; your use of them is governed by the express license under which they were
 ; provided to you (License). Unless the License provides otherwise, you may
 ; not use, modify, copy, publish, distribute, disclose, or transmit this
 ; software or the related documents without Intel's prior written permission.
 ;
 ; This software and the related documents are provided as is, with no express
 ; or implied warranties, other than those that are expressly stated in the
 ; License.

(deffunction tokenize (?delimiter ?string)
 "Given a delimiter and a string, return a multifield list containing
 the sequential tokens.  For example, (tokenize '.' '1.2.3')
 returns ('1', '2', '3')."
 ; create a multifield list to store the tokenized strings
 (bind ?tokens (create$))
 ; find the first occurrence of the token
 (bind ?index (str-index ?delimiter ?string))

 ; loop until all tokens have been processed
 (while (neq ?index FALSE)
  ; extract the string up to, but not including, the first instance
  ; of the token
  (bind ?value (sub-string 1 (- ?index 1) ?string))
  ; add the extracted value to the list of values
  (bind ?tokens (insert$ ?tokens (+ (length$ ?tokens) 1) ?value))
  ; shorten the string by removing the first value and token
  (bind ?string (sub-string (+ ?index 1) (str-length ?string) ?string))
  ; find the next occurrence of the token
  (bind ?index (str-index ?delimiter ?string)))

    ; save the value after the last token (if the token itself did not
            ; terminate the string)
    (if (neq (str-length ?string) 0) then
     (bind ?tokens (insert$ ?tokens (+ (length ?tokens) 1) ?string)))

(return ?tokens))
