; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ip-address-not-consistent
  "If the ip address of a node differs from the perspective of
   different nodes, this rules will fire. The ip address of a
   particular node must be the same on all cluster nodes."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? all_to_all $?))
  ?obj <- (object (is-a ALL_TO_ALL) (node_id ?node)
                  (ip-address ?ip&:(!= (str-length ?ip) 0))
                  (perspective-node_id ?pnode)
                  (multiset_control TRUE))
  (object (is-a NODE) (node_id ?pnode))
  (test (< (send ?obj fraction
                 (sym-cat (send ?obj uniformity-key) ?node) ?ip) 0.9))
  =>
  (bind ?fraction (* 100 (send ?obj fraction
                               (sym-cat (send ?obj uniformity-key) ?node) ?ip)))
  (make-instance of BOOLEAN_SIGN (node_id ?pnode)
                 (confidence (- 100 ?fraction)) (severity 80) (source ?obj)
                 (state observed) (value TRUE) (id "ip-address-not-consistent")
                 (args (create$ ?fraction ?node ?ip))))
