; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule unable-to-obtain-ip-address
  "If hostname -i does not return a valid ip address, the analyze extension
   will pass an empty string to the clips slot for the ip address and
   this rule will fire."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? all_to_all $?))
  ?obj <- (object (is-a ALL_TO_ALL) (node_id ?node)
                  (ip-address ?ip) (perspective-node_id ?pnode))
  (object (is-a NODE) (node_id ?pnode))
  (test (= (str-compare ?ip "") 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?pnode)
                 (confidence 30) (severity 80) (source ?obj)
                 (state observed) (value TRUE)
                 (id "unable-to-obtain-ip-address")
                 (args (create$ ?node))))
