; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule bios_checker-turbo
  "Check that Intel(R) Turbo is enabled"
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? bios_checker $?))
  (object (is-a NODE) (node_id ?node))
  ?obj <- (object (is-a BIOS_CHECKER)
                  (node_id ?node) (turbo-compliant ?turbo-compliant))
  (not (object (is-a SIGN) (node_id ?node) (id "bios_checker-turbo-disabled")))
  (test (= ?turbo-compliant 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 65) (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "bios_checker-turbo-disabled")
                 (remedy "bios_checker-enable-turbo-in-bios"))
)
