; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-missing-kernel-flag
  "Check for missing CPU kernel flag"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
          (flags $?flags) (req-flags $? ?flag $?))
  (test (not (member$ ?flag ?flags)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 80) (severity 40) (source ?obj)
                 (state observed) (value TRUE)
                 (id "cpu-missing-kernel-flag") (sub-id (str-cat ?flag))
                 (remedy "cpu-missing-kernel-flag-remedy") (args (create$ ?flag))))
