; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-model-name-not-uniform
  "Check that the cpu model-name is uniform."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (model-name ?m))
  (test (< (send ?obj fraction (send ?obj uniformity-key model-name) ?m) 0.9))
  =>
  (bind ?percent (* 100 (send ?obj fraction
                              (send ?obj uniformity-key model-name) ?m)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (- 100 ?percent)) (severity 60)
                 (state observed) (source ?obj) (value TRUE)
                 (id "cpu-model-name-not-uniform")
                 (args (create$ ?m ?percent))))

