; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-not-fma
  "Checks if the processor provides at least two 512-bit Fused-Multiply-Add
   (FMA) execution units per core."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node)
          (role $?node-role))
  ?obj <- (object (is-a CPU) (node_id ?node) (model-name ?m))
  (test (and (eq (str-index "Gold 6" ?m ) FALSE)
             (eq (str-index "Platinum 8" ?m) FALSE)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (severity 50) (state observed) (value TRUE)
          (id "cpu-not-fma")
          (args (create$ ?m))))

