; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-tickless-list-not-uniform
  "nohz_full parameter uniformity check for Intel(R) Xeon Phi(TM) processor"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
                  (cpu-type ?cputype) (dmesg-stderr ?stderr)
                  (kernel-nohz-errormsg ?error-msg) (tickless-list-usr ?tlist))
  (test (cpu-test ?cputype "xeon"))
  (test (eq (str-length ?stderr) 0))
  (test (eq (str-length ?error-msg) 0))
  (test (< (send ?obj fraction (send ?obj uniformity-key tickless-list-usr) ?tlist) 0.9))
  =>
  (bind ?percent (* 100 (send ?obj fraction
                              (send ?obj uniformity-key tickless-list-usr) ?tlist)))
  (bind ?id "cpu-tickless-list-not-uniform")
  (if (eq (str-length ?tlist) 0) then
    (bind ?id "cpu-tickless-list-not-uniform-nil"))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (- 100 ?percent)) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id ?id)
                 (sub-id (str-cat ?tlist))
                 (remedy "cpu-tickless-list-not-uniform-remedy")
                 (args (create$ ?tlist ?percent))))

