; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-tickless-rcu-nocbs
  "Check if cpu list in use for nohz_full parameter for the
   Intel(R) Xeon Phi(TM) processor is subset of rcu_nocbs
   paramter (if present)"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
                  (cpu-type ?cputype) (dmesg-stderr ?stderr)
                  (kernel-nohz-errormsg ?error-msg) (tickless-list-usr ?tlist)
                  (cpu-list-ncb ?nlist))
  (test (cpu-test ?cputype "xeon"))
  (test (eq (str-length ?stderr) 0))
  (test (eq (str-length ?error-msg) 0))
  (test (neq (str-length ?tlist) 0))
  (test (neq (str-length ?nlist) 0))
  (test (eq (subset_cpu ?tlist ?nlist) FALSE))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 60)
                 (state observed) (source ?obj) (value TRUE)
                 (id "cpu-tickless-rcu-nocbs")
                 (sub-id (str-cat ?nlist))
                 (remedy "cpu-tickless-rcu-nocbs-remedy")
                 (args (create$ ?tlist ?nlist))))

