; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-turbo-status-not-preferred
  "Check if the Intel(R) Turbo Boost Technology status across nodes is same as preferred by the user."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?)
          (preferred-turbo-status ?pstatus))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
                  (intel-pstate-stderr ?stderr) (turbo-status ?tstatus))
  (test (neq ?pstatus nil))
  (test (neq ?tstatus nil))
  (test (eq (str-length ?stderr) 0))
  (test (neq ?pstatus ?tstatus))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 85) (severity 40)
                 (state observed) (source ?obj) (value TRUE)
                 (id "cpu-turbo-status-not-preferred")
                 (sub-id (str-cat ?tstatus))
                 (remedy "cpu-turbo-status-not-uniform-remedy")
                 (args (create$ ?tstatus ?pstatus))))

