; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule cpu-turbo-status-not-uniform
  "Check for the consistency of Intel(R) Turbo Boost Technology status across a subcluster"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?)
          (turbo-status-uniformity-threshold ?threshold))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
          (turbo-status ?tstatus) (intel-pstate-stderr ?stderr))
  (test (eq (str-length ?stderr) 0))
  (test (neq ?tstatus nil))
  (test (< (send ?obj fraction (send ?obj uniformity-key turbo-status) ?tstatus)
            ?threshold))
  =>
  (bind ?percent (* 100 (send
                         ?obj fraction (send ?obj uniformity-key turbo-status)
                                             ?tstatus)))
  (bind ?confidence (- 100 ?percent))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence ?confidence) (severity 40) (source ?obj)
                 (state observed) (value TRUE)
                 (id "cpu-turbo-status-not-uniform") (sub-id (str-cat ?tstatus))
                 (remedy "cpu-turbo-status-not-uniform-remedy")
                 (args (create$ ?percent ?tstatus))))

