; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule intel-pstate-data-missing
  "Check that intel-pstate data is missing."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node))
  ?obj <- (object (is-a CPU) (node_id ?node) (intel-pstate-stderr ?intel-pstate-stderr))
  (test (eq ?intel-pstate-stderr "data-missing"))
  =>
  (bind ?id "intel-pstate-data-missing")
  (bind ?remedy "intel-pstate-data-missing-remedy")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id "intel-pstate-data-missing")
                 (remedy "intel-pstate-data-missing-remedy")))
