; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule latest-xp-hwloc-memoryside-cache-file
  "Check that the memoryside cache file for the Intel(R) Xeon Phi(TM)
   processor is the latest version, if not raise a sign"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
          (cpu-type xeonphi))
  ?obj <- (object (is-a XP_MODES) (last-modified ?last-modified&~0)
                  (last-reboot ?last-reboot&~0) (node_id ?node))
  (test (< ?last-modified ?last-reboot))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 50)
                 (state observed) (source ?obj) (value TRUE)
                 (id "latest-xp-hwloc-memoryside-cache-file")
                 (remedy "latest-xp-hwloc-memoryside-cache-file-remedy")))

