; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule logical-cores-not-uniform
  "Check for uniformity of logical core(s) among nodes having
   equivalent CPU(s)"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?)
          (logical-cores-uniformity-threshold ?threshold))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (available-logical-cores ?cores&~0))
  (test (< (send ?obj fraction (send ?obj uniformity-key-model-based
            available-logical-cores) ?cores) ?threshold))
  =>
  (bind ?percent (* 100 (send ?obj fraction
                         (send ?obj uniformity-key-model-based
                          available-logical-cores) ?cores)))
  (bind ?id "logical-cores-not-uniform")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (- 100 ?percent)) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id ?id)
                 (sub-id (str-cat ?cores))
                 (remedy "logical-cores-not-uniform-remedy")
                 (args (create$ ?cores ?percent))))
