; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lscpu-data-error
  "Check that lscpu data is available or unparseable."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node))
  ?obj <- (object (is-a CPU) (node_id ?node)
                             (lscpu-stderr ?lscpu-stderr&:(neq ?lscpu-stderr "data-missing"))
                             (threads-per-core ?threads)
                             (available-logical-cores ?acores)
                             (max-logical-cores ?mcores)
                             (sockets ?sockets))
  (test (or (> (str-length ?lscpu-stderr) 0)
            (eq ?threads 0)
            (eq ?acores 0)
            (eq ?mcores 0)
            (eq ?sockets 0)))
  =>
  (bind ?id "lscpu-data-error")
  (bind ?remedy "lscpu-data-error-remedy")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id ?id)
                 (remedy ?remedy)))
