; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lscpu-data-missing
  "Check that lscpu data is available or unparsaeble."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node))
  ?obj <- (object (is-a CPU) (node_id ?node) (lscpu-stderr ?lscpu-stderr))
  (test (eq ?lscpu-stderr "data-missing"))
  =>
  (bind ?id "lscpu-data-missing")
  (bind ?remedy "lscpu-data-missing-remedy")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id ?id)
                 (remedy ?remedy)))
