; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rhos-min-cpu-model-app-base
  "Checks if the minimum processor model is met."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node)
          (role $?role&:(member$ application ?role))
          (model-name ?m) (cpu-type ?type))
 (test (cpu-model-check ?m "Intel(R) Xeon(R) Silver 4114 CPU @ 2.20GHz" ?type))
  =>
  (bind ?expected_model "Intel(R) Xeon(R) Silver 4114 CPU @ 2.20GHz")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (confidence 50) (severity 50)
          (state observed) (value TRUE)
          (id "rhos-min-cpu-model")
          (remedy "rhos-min-cpu-model-remedy")
          (args (create$ ?m ?expected_model))))

