; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule threads-per-core-not-uniform
  "Check for uniformity of threads per core among nodes having
   equivalent CPU(s) (for valid thread count per core)"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?)
          (threads-per-core-uniformity-threshold ?threshold))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (threads-per-core ?threads&~0)
                             (valid-threads-per-core $?vthreads))
  (test (member$ ?threads $?vthreads))
  (test (< (send ?obj fraction (send ?obj uniformity-key-model-based
            threads-per-core) ?threads) ?threshold))
  =>
  (bind ?percent (* 100 (send ?obj fraction
                        (send ?obj uniformity-key-model-based
                         threads-per-core) ?threads)))
  (bind ?id "threads-per-core-not-uniform")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (- 100 ?percent)) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id ?id)
                 (sub-id (str-cat ?threads))
                 (remedy "threads-per-core-not-uniform-remedy")
                 (args (create$ ?threads ?percent))))
