; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule threads-per-core-unusual
  "Check to see if there is an unusual number of threads"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  ?obj <- (object (is-a CPU) (node_id ?node) (threads-per-core ?threads&~0)
                             (valid-threads-per-core $?vthreads))
  (test (not (member$ ?threads $?vthreads)))
  =>
  (bind ?id "threads-per-core-unusual")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id ?id)
                 (sub-id (str-cat ?threads))
                 (remedy "threads-per-core-unusual-remedy")
                 (args (create$ ?threads))))
