; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule xp-cluster-mode-preferred
  "Check that the cluster mode for the Intel(R) Xeon Phi(TM) processor
   is in preferred mode."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?)
          (preferred-cluster-mode ?preferred-mode))
  (analyze-extension-done)
  (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
          (cpu-type ?cputype))
  (test (cpu-test ?cputype "xeonphi"))
  ?obj <- (object (is-a XP_MODES) (cluster-mode ?mode) (node_id ?node))
  (test (neq ?mode non-numa))
  (test (!= (str-compare ?preferred-mode nil) 0))
  (test (!= (str-compare ?mode ?preferred-mode) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id "xp-cluster-mode-preferred") (sub-id (str-cat ?mode))
                 (remedy "xp-cluster-mode-preferred-remedy")
                 (args (create$ ?mode ?preferred-mode))))

