; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule xp-memory-mode-not-uniform
  "Check that the memory mode for the Intel(R) Xeon Phi(TM) processor
   is uniform"
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?)
          (memory-mode-uniformity-threshold ?threshold))
  (analyze-extension-done)
  (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
          (cpu-type ?cputype))
  (test (cpu-test ?cputype "xeonphi"))
  ?obj <- (object (is-a XP_MODES) (memory-mode ?mode) (node_id ?node))
  (test (neq ?mode numa))
  (test (!= (str-compare ?mode nil) 0))
  (test (<= (multiset-fraction (send ?obj uniformity-key memory-mode) ?mode)
            ?threshold))
  =>
  (bind ?percent (* 100 (multiset-fraction
                         (send ?obj uniformity-key memory-mode) ?mode)))
  (bind ?confidence (- 100 ?percent))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence ?confidence) (severity 40) (source ?obj)
                 (state observed) (value TRUE)
                 (id "xp-memory-mode-not-uniform") (sub-id (str-cat ?mode))
                 (remedy "xp-memory-mode-not-uniform-remedy")
                 (args (create$ ?percent ?mode))))

