; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule xp-modes-data-missing
  "Check the modes data for the Intel(R) Xeon Phi(TM) processor is available."
  (object (is-a CONFIG) (name [config]) (clck-checks $? cpu $?))
  (analyze-extension-done)
  (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
          (cpu-type ?cputype))
  (test (cpu-test ?cputype "xeonphi"))
  (not (object (is-a XP_MODES) (node_id ?node)))
  =>
  (bind ?remedy "xp-modes-data-missing-remedy")
  (if (eq ?cputype xeonphi_m) then
    (bind ?remedy "xp-modes-data-missing-remedy-1"))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id "xp-modes-data-missing")
                 (remedy ?remedy)))

