; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule datconf-no-dapl-providers
  "Check that datconf data is available."
  (object (is-a CONFIG) (name [config]) (clck-checks $? datconf $?))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (object (is-a INFINIBAND_PCI_DEVICE) (device ?d)
                  (node_id ?node))
  ?obj <- (object (is-a DATCONF) (node_id ?node) (device-name ?name)
                  (common-adapter ?ca) (dapl-providers $?dapl-providers))
  (test (eq (length$ ?dapl-providers) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (source ?obj)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id "datconf-no-dapl-providers")
                 (args (create$ ?name ?ca))))


