; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule no_hfi_detected
  "No HFI is found on the node."
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? devices $?))
  (object (is-a LSPCI_DEVICES) (node_id ?node)
                        (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role))
                        (device_types $?d_t&: (not (member$ SEPERATE_HFI_DEVICE ?d_t))&:
                                              (not (member$ INTEGRATED_HFI_DEVICE ?d_t))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (confidence 70) (severity 90)
          (state observed) (value TRUE)
          (id "no_hfi_detected")
          (remedy "no_hfi_detected-remedy"))
)
