; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule hfi_x16_missing
  "Identify if there is at least one x16 bus HFIs on
    each compute node (100GBps)."
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? devices $?))
   ?obj <-(object (is-a LSPCI_DEVICES) (node_id ?node)
                         (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role))
                         (device_idxs $? ?didx $?))
  (test (and (or (eq (send ?obj get-device-type-by-idx ?didx) INTEGRATED_HFI_DEVICE)
                 (eq (send ?obj get-device-type-by-idx ?didx) SEPERATE_HFI_DEVICE))
             (neq (str-compare (send ?obj get-device-width-by-idx ?didx) access_denied) 0)
             (neq (str-compare (send ?obj get-device-width-by-idx ?didx) x16) 0)
        ))
=>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (source ?obj)
          (confidence 90) (severity 90)
          (state observed) (value TRUE)
          (id "hfi_x16_missing")))
