; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lspci_verbose_data_missing
  "Identify if there is data missing for devices that uses the provider lspci_verbose."
  (object (is-a CONFIG)
    (name [config])
    (clck-checks $? devices $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (not (object (is-a LSPCI_DEVICES) (node_id ?node)))
 =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (confidence 70) (severity 90)
          (state observed) (value TRUE)
          (id "lspci_verbose_data_missing")
          (remedy "lspci_verbose_data_missing-remedy"))
)
