; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule dgemm-perf-pass
  "Ensure that a system meets the performance requirements defined by
   Intel Select Solutions for HPC"
  (object (is-a CONFIG) (name [config]) (clck-checks $? dgemm $?) (dgemm-perf-threshold ?dgemmthreshold))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node))

  ?obj <- (object (is-a DGEMM) (flops ?flops&~0) (node_id ?node)
       (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (test (< (/ ?flops 1e9) ?dgemmthreshold))
  =>
 (make-instance of PERFORMANCE_SIGN
   (node_id ?node)
   (confidence 99)
   (severity 50)
   (state observed)
   (source ?obj)
   (value TRUE)
   (id "dgemm-perf-pass")
   (remedy "dgemm-perf-pass-remedy")
   (args ( / ?flops 1e9) ?dgemmthreshold)
 )
)
