; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule environment-variable-not-uniform
  "Check that an environment variable is uniform."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? environment $?)
          (environment-blacklist $?blacklist))
  ?obj <- (object (is-a ENVIRONMENT)
                  (node_id ?n) (multiset_control TRUE)
                  (variable ?k) (value ?v) (true-value ?tv)
                  (envblacklist $?bl)
                  (require-uniformity TRUE))
  (test (< (send ?obj fraction (send ?obj uniformity-key) ?v) 0.9))
  (test (= (regex_match ?k $?blacklist) 0))
  (test (= (regex_match ?k $?bl) 0))
  =>
  (bind ?fraction (send ?obj fraction (send ?obj uniformity-key) ?v))
  (make-instance of BOOLEAN_SIGN (node_id ?n) (severity 40) (source ?obj)
                 (confidence (* 100 (- 1 ?fraction))) (state observed)
                 (value TRUE)
                 (id "environment-variable-not-uniform") (sub-id (str-cat ?k))
                 (args (create$ (* 100 ?fraction) ?k ?tv))))

