; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ethernet-driver-version-is-not-consistent
  "Identify inconsistent Ethernet driver versions."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ethernet $?))
  ?obj <- (object (is-a ETHERNET) (multiset_control TRUE) (version ?v)
                  (node_id ?node))
  (object (is-a NODE) (node_id ?node))
  (test (< (send ?obj fraction (send ?obj uniformity-key version) ?v) 0.9))
  =>
  (bind ?fraction (- 1 (send ?obj fraction
                             (send ?obj uniformity-key version) ?v)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (* 100 ?fraction)) (severity 25)
                 (state observed) (source ?obj) (value TRUE)
                 (id "ethernet-driver-version-is-not-consistent")
                 (args (create$
                        (* 100 (send ?obj fraction
                                     (send ?obj uniformity-key version) ?v))
                        ?v))))

