; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ethernet-interrupt-coalescing-is-enabled
  "Identify nodes where Ethernet interrupt coalescing is not disabled,
   i.e., rx-usecs is not 0 or 1.  This only matters when using
   Ethernet as the MPI message fabric.  Since the same node may be in
   multiple IMB pingpong pairs, check to see if the sign has already
   been created to avoid duplicates."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ethernet $?))
  (object (is-a IMB_PINGPONG) (node_id $? ?node $?)
          (i_mpi_fabrics shm:tcp | tcp) (i_mpi_tcp_netmask ?i))
  ?obj <- (object (is-a ETHERNET) (node_id ?node) (interface ?i)
                  (rx-usecs ~0 & ~1))
  (object (is-a NODE) (node_id ?node))
  (not (object (is-a SIGN) (id "ethernet-interrupt-coalescing-is-enabled")
               (source ?obj)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 90) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id "ethernet-interrupt-coalescing-is-enabled")
                 (sub-id (str-cat ?i)) (args ?i)
                 (remedy "ethernet-interrupt-coalescing-is-enabled-remedy")
                 (remedy-args ?i)))

