; Copyright 2016-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule files-group
  "Compare the current file group to the baseline."
  (object (is-a CONFIG) (name [config]) (clck-checks $? files $?))
  ?obj <- (object (is-a FILES)
    ; (slot_name ?var_name)
    (node_id ?node)      ; host in question
    (group_ref ?group_ref&:(neq ?group_ref ""))   ; baseline group
    (group_test ?group_test&:(neq ?group_test ""))   ; database group
    (file ?filename)  ; file in question
    (attribute ?attr&:(eq ?attr 3)); attribute 3 for group
  )
  (object (is-a NODE) (node_id ?node))

  ; if the baseline and current perms are mismatched
  (test (<> (str-compare ?group_ref ?group_test) 0))
  =>
  ; FIRE!
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)  ; miniscule likelihood of this being a false result
    (severity 15)    ; non-critical, and easily fixed
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "files-group")
    (args (create$ ?filename ?group_ref ?group_test))
  )
)
