; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule hw-added
  "See if hardware has been added relative to the baseline."
  (object (is-a CONFIG) (name [config]) (clck-checks $? hardware $?))
  ?obj <- (object (is-a HARDWARE)
    (node_id  ?node)     ; host in question
    (hw_location_test ?hw_location_test) ; hw location in question
    (hw_info_test ?hw_info_test) ; hw info in question
    (status  ?status)   ; added since baseline
  )
  (object (is-a NODE) (node_id ?node))

  ; if the file has been added since the baseline was made
  (test (= (str-compare ?status "extra") 0))
  =>
  ; FIRE!
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 15)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "hw-added")
    (args (create$ ?hw_location_test ?hw_info_test))
  )
)
