; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule hw-modified
  "Compare the current output line to the baseline."
  (object (is-a CONFIG) (name [config]) (clck-checks $? hardware $?))
  ?obj <- (object (is-a HARDWARE)
    ; (slot_name ?var_name)
    (node_id  ?node)      ; host in question
    (hw_location_ref ?hw_location_ref&:(neq ?hw_location_ref "")) ; baseline
    (hw_info_ref ?hw_info_ref&:(neq ?hw_info_ref "")) ; baseline
    (hw_info_test ?hw_info_test&:(neq ?hw_info_test "")) ; baseline
    (status  ?status)   ; modified since baseline
  )
  (object (is-a NODE) (node_id ?node))

  ; if the baseline and current hw_info are mismatched
  (test (<> (str-compare ?hw_info_ref ?hw_info_test) 0))
  =>
  ; FIRE!
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)  ; miniscule likelihood of this being a false result
    (severity 15)    ; non-critical, and easily fixed
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "hw-modified")
    (args (create$ ?hw_location_ref ?hw_info_ref ?hw_info_test))
  )
)
