; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule hpcg-cluster-error
  "Detect cases where the HPCG_CLUSTER data is invalid, i.e., data provider
   output exists in the database, but the analyze extension could not parse
   it."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? hpcg_cluster $?))
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  ?obj <- (object (is-a HPCG_CLUSTER) (node_id ?node) (perf -1))
  =>
  (make-instance of BOOLEAN_SIGN (node_id (send ?obj get-node_id))
                 (confidence 60) (severity 70) (state observed) (source ?obj)
                 (value TRUE) (id "hpcg-cluster-error")))
