; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule hpcg-single-perf-pass
  "Identify nodes that do not meet the HPCG single-node minimum performance
   requirements in the Intel(R) Select Solution for HPC program."
  (object (is-a CONFIG) (name [config]) (clck-checks $? hpcg_single $?)
          (hpcg-single-perf-threshold ?threshold))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node)
    (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  ?obj <- (object (is-a HPCG_SINGLE) (node_id ?node)
                  (perf ?perf&:(neq ?perf -1)))
  (test (< ?perf ?threshold))
  =>
  (make-instance of PERFORMANCE_SIGN
    (node_id (send ?obj get-node_id))
    (confidence 99)
    (severity 50)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "hpcg-single-perf-pass")
    (remedy "hpcg-single-perf-pass-remedy")
    (args ?perf ?threshold)
 )
)
