; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule hpl-4node-perf-pass
   "Ensure that a system meets the performance requirements defined by
   Intel Select Solutions for HPC"
  (object (is-a CONFIG) (name [config]) (clck-checks $? hpl $?)
          (hpl-4node-perf-threshold ?hplthreshold))
  (analyze-extension-done)
  ?obj <- (object (is-a HPL) (provider CLUSTER)
                             (residual PASSED)
                             (gflops ?gflops))
  ; check for good values
  (test (and (> ?gflops 0)
            (< ?gflops ?hplthreshold)))
  =>
  (make-instance of PERFORMANCE_SIGN
    (node_id (send ?obj get-node_id))
    (confidence 99)
    (severity 90)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "hpl-4node-perf-pass")
    (remedy "hpl-4node-perf-pass-remedy")
    (args ?gflops ?hplthreshold)
  )
)
