; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule imb-pingpong-bandwidth-perf-pass
   "Ensure that a system meets the performance requirements defined by.
   Intel Select Solutions for HPC"
  (object (name [config]) (clck-checks $? imb_pingpong $?)
       (imb_pingpong-bandwidth-perf-threshold ?imbthreshold))
  (analyze-extension-done)
  ?obj <- (object (is-a IMB_PINGPONG) (node_id ?node0 ?node1)
                  (bandwidth ?bandwidth))
  (object (is-a NODE) (node_id ?node0)(role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (object (is-a NODE) (node_id ?node1)(role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (test (< ?bandwidth ?imbthreshold))
  =>
 (make-instance of PERFORMANCE_SIGN
   (node_id (send ?obj get-node_id))
   (confidence 99)
   (severity 50)
   (state observed)
   (source ?obj)
   (value TRUE)
   (id "imb-pingpong-bandwidth-perf-pass")
   (remedy "imb-pingpong-bandwidth-perf-pass-remedy")
   (sub-id (str-cat (send ?obj get-i_mpi_fabrics)))
   (args ?bandwidth ?imbthreshold)
 )
)
