; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule imb-pingpong-bandwidth-threshold
  "Check that the measured Intel(R) MPI Benchmark PingPong bandwidth
   is greater than or equal to the expected bandwidth."
  (object (name [config]) (clck-checks $? imb_pingpong $?))
  ?obj <- (object (is-a IMB_PINGPONG) (node_id ?node0 ?node1)
                  (bandwidth ?bandwidth)
                  (expected-bandwidth ?expected-bandwidth&~0.0))
  (object (is-a NODE) (node_id ?node0))
  (object (is-a NODE) (node_id ?node1))
  (test (< ?bandwidth ?expected-bandwidth))
  =>
  (bind ?severity (* (- 1 (gaussian (abs ?bandwidth) ?expected-bandwidth
                                    (/ (abs ?bandwidth) 2))) 80))
  (make-instance of BOOLEAN_SIGN (node_id (create$ ?node0 ?node1))
                 (confidence 50) (severity ?severity)
                 (state observed) (source ?obj) (value TRUE)
                 (id "imb-pingpong-bandwidth-threshold")
                 (sub-id (str-cat (send ?obj get-i_mpi_fabrics)))
                 (args (create$ ?bandwidth ?expected-bandwidth
                                (send ?obj get-impi-setting-string)))))

