; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule imb-pingpong-latency-outlier
  "Check that the measured Intel(R) MPI Benchmark PingPong latency
   is within the statistical range defined by other measured values in
   the same grouping."
  (object (name [config])
          (clck-checks $? imb_pingpong $?)
          (imb-pingpong-number-of-mad ?num-mad)
          (outlier-max-median-mad-dist ?med-mad-dist)
          (outlier-median-pct ?median-pct))
  ?obj <- (object (is-a IMB_PINGPONG) (node_id ?node0 ?node1) (latency ?perf)
                  (arch ?arch ?arch) (endpoints remote)
                  (statistics_control TRUE))

  (object (is-a NODE) (node_id ?node0))
  (object (is-a NODE) (node_id ?node1))

  (test (send ?obj outlier (send ?obj statistics-key latency)
              ?perf ?num-mad ?med-mad-dist ?median-pct))
  =>
  (bind ?key (send ?obj statistics-key latency))
  (bind ?stat-instance (send ?obj _find_pair ?key))

  (bind ?median (send ?stat-instance median))
  (bind ?margin (send ?stat-instance get-outlier-margin))

  (bind ?severity (send ?obj outlier-severity ?key ?perf 25 60))

  (make-instance of BOOLEAN_SIGN (node_id (create$ ?node0 ?node1))
                 (confidence 50) (severity ?severity)
                 (state observed) (source ?obj) (value TRUE)
                 (id "imb-pingpong-latency-outlier")
                 (sub-id (str-cat (send ?obj get-i_mpi_fabrics)))
                 (args (create$ ?perf ?median ?margin
                                (send ?obj get-impi-setting-string)))))

