; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule imb-pingpong-latency-threshold
  "Check that the measured Intel(R) MPI Benchmark PingPong latency is
   less than or equal to the expected latency."
  (object (name [config]) (clck-checks $? imb_pingpong $?))
  ?obj <- (object (is-a IMB_PINGPONG) (node_id ?node0 ?node1)
                  (latency ?latency)
                  (expected-latency ?expected-latency&~1e6))
  (object (is-a NODE) (node_id ?node0))
  (object (is-a NODE) (node_id ?node1))
  (test (> ?latency ?expected-latency))
  =>
  (bind ?severity (* (- 1 (gaussian (abs ?latency) ?expected-latency
                                    (/ (abs ?latency) 2))) 80))
  (make-instance of BOOLEAN_SIGN (node_id (create$ ?node0 ?node1))
                 (confidence 50) (severity ?severity)
                 (state observed) (source ?obj) (value TRUE)
                 (id "imb-pingpong-latency-threshold")
                 (sub-id (str-cat (send ?obj get-i_mpi_fabrics)))
                 (args (create$ ?latency ?expected-latency
                                (send ?obj get-impi-setting-string)))))

