; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule infiniband-memlock-is-not-consistent
  "Identify inconsistent memlock limits."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? infiniband $?))
  ?obj <- (object (is-a INFINIBAND_CONFIG) (node_id ?node)
                  (memlock ?memlock&~0) (multiset_control TRUE))
  (object (is-a INFINIBAND_PCI_DEVICE) (node_id ?node))
  (object (is-a NODE) (node_id ?node))
  (test (< (send ?obj fraction (send ?obj multiset-key memlock) ?memlock) 0.9))
  =>
  (bind ?key (send ?obj multiset-key memlock))
  (bind ?fraction (- 1 (send ?obj fraction ?key ?memlock)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence (* 100 ?fraction))
                 (severity 30) (state observed) (source ?obj) (value TRUE)
                 (id "infiniband-memlock-is-not-consistent")
                 (args (* 100 (send ?obj fraction ?key ?memlock))
                       ?memlock)))

