; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule infiniband-memlock-too-small
  "Identify too low memlock limits."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? infiniband $?))
  ?obj <- (object (is-a INFINIBAND_CONFIG) (node_id ?node)
                  (memlock ?memlock))
  (object (is-a INFINIBAND_PCI_DEVICE) (node_id ?node))
  (object (is-a NODE) (node_id ?node))
  (test (and (< ?memlock 200000) (!= ?memlock -1)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 90)
                 (severity 70) (state observed) (source ?obj) (value TRUE)
                 (id "infiniband-memlock-too-small")
                 (args ?memlock)
                 (remedy "infiniband-memlock-too-small-remedy")))

