; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule infiniband-port-state-not-active
  "Identify InfiniBand HCA ports not in the Active state."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? infiniband $?))
  ?obj <- (object (is-a INFINIBAND_HCA) (state ?s&~Active) (node_id ?node))
  (object (is-a NODE) (node_id ?node))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 65) (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "infiniband-port-state-not-active")
                 (sub-id (str-cat (send ?obj get-ca) - (send ?obj get-port)))
                 (args (create$ (send ?obj get-ca) (send ?obj get-port) ?s))))

