; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule infiniband-rate-is-not-consistent
  "Identify inconsistent InfiniBand HCA rate."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? infiniband $?))
  ?obj <- (object (is-a INFINIBAND_HCA) (rate ?r)
                  (multiset_control TRUE) (node_id ?node))
  (object (is-a NODE) (node_id ?node))
  (test (< (send ?obj fraction (send ?obj multiset-key rate) ?r)
           0.9))
  =>
  (bind ?key (send ?obj multiset-key rate))
  (bind ?fraction (- 1 (send ?obj fraction ?key ?r)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (* 100 ?fraction)) (severity (* 80 ?fraction))
                 (state observed) (source ?obj) (value TRUE)
                 (id "infiniband-rate-is-not-consistent")
                 (sub-id (str-cat (send ?obj get-ca) - (send ?obj get-port)))
                 (args (create$
                        (send ?obj get-ca)
                        (send ?obj get-port)
                        (* 100 (send ?obj fraction ?key ?r))
                        ?r))))

