; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule infiniband-subnet-manager-not-running
  "Check that a subnet manager is running for infiniband."
  (object (is-a CONFIG) (name [config]) (clck-checks $? infiniband $?))
  (object (is-a INFINIBAND_PCI_DEVICE) (node_id ?node))
  ?obj <- (object (is-a SAQUERY_INFO) (node_id ?node)
                  (class_version ?class_version))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (!= ?class_version 2))
  (not (object (is-a SIGN) (id "missing-saquery-tool") (node_id ?node)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 80) (state observed) (source ?obj) (value TRUE)
                 (id "infiniband-subnet-manager-not-running")
                 (args ?class_version)
                 (remedy "infiniband-subnet-manager-not-running-remedy")))

