; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule no-fabrics-detected
  "This rule ensures that if no fabrics are detected Intel HPC Platform high
   performance fabric does not pass."
  (object (is-a CONFIG) (name [config]))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (not (object (is-a SIGN) (id "no-fabrics-detected") (node_id ?node)))
  (and (not (object (is-a INFINIBAND_PCI_DEVICE) (node_id ?node)))
      (not (object (is-a OPA_PCI_DEVICE) (node_id ?node)))
      (not (object (is-a ETHERNET) (node_id ?node))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 75)
                 (state observed) (value TRUE)
                 (id "no-fabrics-detected")
                 (remedy "no-fabrics-detected-remedy")))

