; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule intel_hpcp_version-file-not-found
  "If no Intel HPC Platform versions are found and stderr contains
   the string 'No such file or directory', then the file is missing."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? intel_hpcp_version $?))
  ?obj <- (object (is-a INTEL_HPC_PLATFORM_VERSION) (node_id ?node)
                  (stderr ?err) (latest-timestamp TRUE))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (str-index "No such file or directory" ?err))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 80) (source ?obj)
                 (state observed) (value TRUE)
                 (remedy "intel_hpcp_version-file-error-remedy")
                 (id "intel_hpcp_version-file-not-found")))

