; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule missing-layer-sdvis-core-2018.0
  "Checks whether the required string sdvis-core-2018.0 is included in
   /etc/intel-hpc-platform-release."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? intel_hpcp_version $?))
  ?obj <- (object (is-a INTEL_HPC_PLATFORM_VERSION) (node_id ?node)
                  (layer $?layer) (stderr ?err) (latest-timestamp TRUE))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (not (member$ sdvis-core-2018.0 ?layer)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 80) (source ?obj)
                 (state observed) (value TRUE)
                 (id "missing-layer-sdvis-core-2018.0")
                 (remedy "missing-layer-dependency-remedy")
                 (args (create$ "sdvis-core-2018.0"))))

