; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule iozone-ran-no-bandwidth
  "This rule fires on nodes that have bandwidth as 0.0. This is the
   default value and if this is the value found, it means the
   analyze extension didn't find a regular expression match for the correct
   BW."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? iozone $?))
  ?obj <- (object (is-a IOZONE) (node_id ?hostname) (latest-timestamp TRUE)
                  (stdout ?out) (bandwidth 0))
  (object (is-a NODE) (node_id ?hostname))
  (test (> (str-length ?out) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 60) (severity 90)
                 (state observed) (value TRUE) (source ?obj)
                 (id "iozone-ran-no-bandwidth")))

