; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule iozone-ran-not-complete
  "This rules fires on nodes where bandwidth is greater than
   0.0, (which means the test finished and the analyze extension found a
   value) but the string 'iozone test complete' is missing from the
   output. This could mean a slow hard disk, or perhaps a failing hard
   disk, so let's warn the user"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? iozone $?))
  ?obj <- (object (is-a IOZONE) (node_id ?hostname) (latest-timestamp TRUE)
                  (stdout ?out) (bandwidth ?bandwidth))
  (object (is-a NODE) (node_id ?hostname))
  (test (> ?bandwidth 0.0)) ; iozone ran and we got the bandwidth we want
  (test (eq (str-index "iozone test complete" ?out) FALSE))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 60) (severity 50)
                 (state observed) (value TRUE) (source ?obj)
                 (id "iozone-ran-not-complete")))

