; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule kernel-not-core-2018.0
  "If the kernel version is less than 3.10.0 then kernel is not compliant with
   the layer core-2018.0 or the Intel HPC Platform Specification. If the base
   (everything before -) has letters, the analyze extension will pass a flag !
   to clips instead of the actual base version."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? kernel $?))
  ?obj <- (object (is-a KERNEL) (latest-timestamp TRUE) (node_id ?hostname)
                  (FullVersion ?fullV) (base ?ver) (extension ?ext))
  (object (is-a NODE) (node_id ?hostname) (architecture x86_64) (role $?role))
  (test (or (member$ compute ?role) (member$ login ?role)
          (member$ service ?role) (member$ head ?role)))
  (test
   (or (= (str-length ?ver) 0)
       (< (vercmp ?ver "3.10.0") 0)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (severity 80) (source ?obj)
                 (state observed) (value TRUE) (id "kernel-not-core-2018.0")
                 (args (create$ ?fullV))))

