; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule kernel-not-ssf-core-2016.0
  "If the kernel version is less than 2.6.32 then kernel is
   not Intel(R) Scalable System Framework compliant. If the base (everything
   before -) has letters, the analyze extension will pass a flag ! to clips
   instead of the actual base version."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? kernel $?))
  ?obj <- (object (is-a KERNEL) (latest-timestamp TRUE) (node_id ?hostname)
                  (FullVersion ?fullV) (base ?ver) (extension ?ext))
  (object (is-a NODE) (node_id ?hostname) (architecture x86_64))
  (test
   (or (= (str-length ?ver) 0)
       (< (vercmp ?ver "2.6.32") 0)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 90) (severity 70) (source ?obj)
                 (state observed) (value TRUE) (id "kernel-not-ssf-core-2016.0")
                 (args (create$ ?fullV))))

