; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule kernel-param-not-preferred
  (object (is-a CONFIG) (name [config]) (clck-checks  $? kernel_param $?)
                        (kernel-param-preferred $? ?load-param $?))
  ?obj<-(object (is-a KERNEL_PARAM) (node_id ?node) (role $? ?role $?) (params $?params&:(> (length$ ?params) 0)))
  (analyze-extension-done)
  (test (= (length$ (tokenize "|" ?load-param)) 3))
  ;; role applicable ?
  (test (= (str-compare (nth$ 2 (tokenize "|" ?load-param)) ?role) 0))
  (test (neq (member$ (sym-cat (nth$ 1 (tokenize "|" ?load-param))) ?params) FALSE))
  ;; check preferred value
  (test
    (neq (str-compare (str-cat (nth$ 2 (tokenize "|" ?load-param)) "." (nth$ 3 (tokenize "|" ?load-param))) (str-cat ?role "." (send ?obj get-value (sym-cat (nth$ 1 (tokenize "|" ?load-param)))))) 0)
  )
  =>
  (bind ?param-name (sym-cat (nth$ 1 (tokenize "|" ?load-param))))
  (bind ?param-value (send ?obj get-value ?param-name))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id "kernel-param-not-preferred")
                 (remedy "kernel-param-not-preferred-remedy")
                 (args (create$ ?param-name ?param-value (nth$ 3 (tokenize "|" ?load-param))))))

