; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule kernel-param-not-uniform
  (object (name [config])
          (clck-checks $? kernel_param $?)
          (kernel-blacklist $?blacklist)
          (kernel-param-uniformity-threshold ?thresh))
  (analyze-extension-done)
  ?obj <- (object (is-a KERNEL_PARAM)
                  (node_id ?n)
                  (role $?role)
                  (params $? ?param $?))
  (test (= (regex_match ?param $?blacklist) 0))
; run the rule if 
; 1> the status is extra, and the role is not head/compute
; 2> the status is non-uniform
  (test (or (and (eq (send ?obj get-status ?param) non-uniform)
                 (or  (member$ compute ?role) (member$ enhanced ?role)))
            (and (eq (send ?obj get-status ?param) extra)
                 (and (or  (member$ compute ?role) (member$ enhanced ?role))
                      (not (member$ head ?role))))))
  (test (< (multiset-fraction (send ?obj uniformity-key ?param) (send ?obj get-value ?param)) ?thresh))
  =>
  (bind ?fraction (* 100 (multiset-fraction (send ?obj uniformity-key ?param) (send ?obj get-value ?param))))
  (bind ?confidence (- 100 ?fraction))

  (make-instance of BOOLEAN_SIGN (node_id ?n) (severity 40) (source ?obj)
                 (confidence ?confidence) (state observed) (value TRUE)
                 (id "kernel-param-not-uniform") (sub-id (str-cat ?param))
                 (args (create$ ?fraction ?param (send ?obj get-value ?param)))))

