; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule libfabric-library-missing
  "Checks whether each node includes the mesa package version 1.4.0 or
   greater, as required by the Intel HPC Platform Specification layer
   sdvis-core-2018.0."
  (object (is-a CONFIG) (name [config]) (clck-checks $? ldconfig $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node) (role $?role))
  ?obj <- (object (is-a LDCONFIG) (node_id ?node) (libraries $?libraries)
                  (req-libfabric $? ?req $?))
  (test (not (member$ ?req ?libraries)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 75) (source ?obj)
                 (state observed) (value TRUE) (id "libfabric-library-missing")))
