; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mesa-library-wrong-version
  "Check for libraries required by mesa."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ldconfig $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a LDCONFIG) (node_id ?n)
                  (libraries $?libraries) (req-mesa $? ?req $?))
  (test (member$ ?req ?libraries))
  (test (neq (str-compare (send ?obj find-version ?req) "none") 0))
  (test (or (= (str-length (send ?obj find-version ?req)) 0)
            (< (vercmp (send ?obj find-version ?req)
                       (send ?obj find-mesa-req-version ?req)) 0)))
  =>
  (bind ?rver (send ?obj find-mesa-req-version ?req))
  (bind ?ver (send ?obj find-version ?req))
  (bind ?id "mesa-library-wrong-version")
 (make-instance of BOOLEAN_SIGN (node_id ?n)
                (severity 75) (sub-id ?req)
                (value TRUE) (state observed) (source ?obj)
                (id ?id) (args ?req ?ver ?rver)))
