; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ospray-library-version-not-detected
  "Check for libraries required by ospray."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ldconfig $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a LDCONFIG) (node_id ?n)
                  (libraries $?libraries) (ospray-libraries $? ?req $?))
  (test (member$ ?req ?libraries))
  (test (eq (str-compare (send ?obj find-version ?req) "none") 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 75) (sub-id ?req)
                 (value TRUE) (state observed) (source ?obj)
                 (id "ospray-library-version-not-detected") (args ?req)))
