; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lshw-key-missing
  (object (is-a CONFIG) (name [config])
          (clck-checks $? lshw $?) (lshw-blacklist $?blacklist)
          (lshw-uniformity-threshold ?thresh))
  (analyze-extension-done)
  ?obj <- (object (is-a LSHW) (node_id ?node)
                  (architecture x86_64)
                  (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role))
                  (builtin-blacklist $?builtin-blacklist)
                  (keys $? ?key $?))
  (test (= (str-length (send ?obj get-value ?key)) 0))
  (test (= (regex_match ?key $?builtin-blacklist) 0))
  (test (= (regex_match ?key $?blacklist) 0))
  (test (< (multiset-fraction (send ?obj uniformity-key ?key) "") ?thresh))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 90) (severity 40)
                 (state observed) (source ?obj) (value TRUE)
                 (id "lshw-key-missing") (sub-id (str-cat ?key))
                 (args (create$ ?key))))

