; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lshw-not-uniform
  (object (is-a CONFIG) (name [config])
          (clck-checks $? lshw $?)
          (lshw-blacklist $?blacklist) (lshw-uniformity-threshold ?thresh))
  (analyze-extension-done)
  ?obj <- (object (is-a LSHW) (node_id ?node) (subcluster ?subcluster)
                  (architecture x86_64)
                  (role $?role)
                  (builtin-blacklist $?builtin-blacklist)
                  (keys $? ?key $?))
  (test (!= (str-length (send ?obj get-value ?key)) 0))
; run the rule if
; 1> the status is extra, and the role is not head/compute
; 2> the status is non-uniform
  (test (or (and (eq (send ?obj get-status ?key) non-uniform)
                 (or  (member$ compute ?role) (member$ enhanced ?role)))
            (and (eq (send ?obj get-status ?key) extra)
                 (and (or  (member$ compute ?role) (member$ enhanced ?role))
                      (not (member$ head ?role))))))
  (test (= (regex_match ?key $?blacklist) 0))
  (test (= (regex_match ?key $?builtin-blacklist) 0))
  (test (< (multiset-fraction (send ?obj uniformity-key ?key) (send ?obj get-value ?key)) ?thresh))
  =>
  (bind ?fraction (* 100 (multiset-fraction (send ?obj uniformity-key ?key)
                               (send ?obj get-value ?key))))
  (bind ?confidence (- 100 ?fraction))

  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence ?confidence) (severity 40) (source ?obj)
                 (state observed) (value TRUE)
                 (id "lshw-not-uniform") (sub-id (str-cat ?key))
                 (args (create$ ?fraction ?key (send ?obj get-value ?key) ?subcluster))))

