; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lshw_storage-data-missing
  "Check that required raid or disk data is available for storage nodes."
  (declare (salience ?*high-salience*))
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config]) (clck-checks $? lshw_disks $?)) 
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ storage ?role)))

  (and (not (object (is-a RAID) (node_id ?node)))
       (not (object (is-a DISK) (node_id ?node))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (state observed) (value TRUE)
                 (id "lshw_storage-data-missing")
                 (remedy "lshw_storage-data-missing-remedy")))

