; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lshw-storage-disk-count-insufficient-plus
  "Check that the number of disks is minimally the number of expected disks,
   used currently for the Red Hat OpenShift Plus Solution"
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? lshw_disks $?))
  ?obj <-(object (is-a DISK_COUNT) (disk-count ?disk-count) (node_id ?node))

  (object (is-a NODE) (node_id ?node) (architecture x86_64) (role $?role))
  (test (member$ storage ?role))
  (test (< ?disk-count 20))
  =>
  (make-instance of BOOLEAN_SIGN
    (node_id (send ?obj get-node_id))
    (confidence 90)
    (severity 90)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "lshw-storage-disk-count-insufficient")
    (args (create$ ?disk-count 20))
    (remedy "lshw-storage-disk-count-insufficient-remedy")
    (remedy-args 20)
  )
)
