; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lshw-storage-disk-firmware-not-uniform
  "Check that the disk firmware versions are uniform."
  (object (is-a CONFIG) (name [config]) (clck-checks $? lshw_disks $?))

  (analyze-extension-done)
  ?obj <- (object (is-a DISK) (node_id ?node) (firmware-version ?firmware-version) (product ?product))

  (object (is-a NODE) (node_id ?node) (role $?role))

  (test (member$ storage ?role))
  (test (< (send ?obj fraction (send ?obj uniformity-key-product-based firmware-version) ?firmware-version)
           1.0))
  =>
  (bind ?key (send ?obj uniformity-key-product-based firmware-version) )
  (bind ?percent (* 100 (send ?obj fraction ?key ?firmware-version)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 0)
                 (severity 70)
                 (state observed)
                 (source ?obj)
                 (value TRUE)
                 (id "lshw-storage-disk-firmware-not-uniform")
                 (args (create$
                        ?percent
                        ?product
                        ?firmware-version))))
