; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lshw-storage-raid-informational
  "If RAID controller is found, fire a sign to remind users to double-check
  their number of disks on nodes with the RAID"
  (analyze-extension-done)

  (object (is-a CONFIG) (name [config])
          (clck-checks $? lshw_disks $?))
  ?obj <-(object (is-a RAID) (node_id ?node))

  (object (is-a NODE) (node_id ?node) (architecture x86_64) (role $?role))
  (test (member$ storage ?role))

  =>
  (make-instance of BOOLEAN_SIGN
    (node_id (send ?obj get-node_id))
    (confidence 90)
    (severity 25)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "lshw-storage-raid-informational")
  )
)
