; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lustre-data-missing
  "Emit sign if there is no lustre data."
  (declare (salience ?*high-salience*))
  (object (is-a CONFIG) (name [config]) (clck-checks $? lustre $?))

  (object (is-a NODE) (node_id ?node) (architecture x86_64)
          (role $?role&:(member$ compute ?role)|:
                (member$ enhanced ?role)) (subcluster ?subcluster))

  (object (is-a LUSTRE) (node_id ?node))
  (not (object (is-a SIGN) (id "lustre-data-missing") (node_id ?node)))
  (or (not (object (is-a LUSTRE_TARGET) (node_id ?node)))
      (not (object (is-a LUSTRE_MOUNT_POINT) (node_id ?node))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id "lustre-data-missing")
                 (remedy "lustre-data-missing-remedy")))

