; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lustre-mount-point-not-mounted
  "Ensures uniformity of mount points."
  (object (is-a CONFIG) (name [config]) (clck-checks $? lustre $?))

  (object (is-a NODE) (node_id ?node) (architecture x86_64)
          (role $?role&:(member$ compute ?role)|:
                (member$ enhanced ?role)) (subcluster ?subcluster))

  (not (object (is-a SIGN) (id "lustre-kernel-modules-loaded-error")
               (node_id ?node)))

  (object (is-a LUSTRE) (node_id ?node))

  ?obj <- (object (is-a LUSTRE_MOUNT_POINT) (node_id ?node)
                  (mount_point ?mount_point) (fs_name ?fs_name) (mounted FALSE))

  =>

  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 80) (source ?obj)
                 (state observed) (value TRUE)
                 (id "lustre-mount-point-not-mounted")
                 (args (create$ ?mount_point ?fs_name))))


