; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lustre-target-inactive
 "Check to see if a target is inactive which is active on other nodes on the
 cluster."
  (object (is-a CONFIG) (name [config]) (clck-checks $? lustre $?))

  (object (is-a NODE) (node_id ?node) (architecture x86_64)
          (role $?role&:(member$ compute ?role)|:
                (member$ enhanced ?role)) (subcluster ?subcluster))

  (not (object (is-a SIGN) (id "lustre-kernel-modules-loaded-error")
               (node_id ?node)))

  (object (is-a LUSTRE) (node_id ?node))

  ?obj <- (object (is-a LUSTRE_TARGET) (node_id ?node)
                  (target ?target) (active FALSE))

  =>

  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 50) (severity 80) (source ?obj)
                 (state observed) (value TRUE)
                 (id "lustre-target-inactive")
                 (args (create$ ?target))))


