; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule lustre-write-targets-uniform
  "Uniformity of object targets that are written to by the stripe test."
  (object (is-a CONFIG) (name [config]) (clck-checks $? lustre $?))

  (object (is-a NODE) (node_id ?node) (architecture x86_64)
          (role $?role&:(member$ compute ?role)|:
                (member$ enhanced ?role)) (subcluster ?subcluster))

  (not (object (is-a SIGN) (id "lustre-kernel-modules-loaded-error")
               (node_id ?node)))

  ?obj <- (object (is-a LUSTRE_MOUNT_POINT) (node_id ?node)
                  (mount_point ?mount_point) (fs_name ?fs_name) (mounted TRUE)
                  (write_object_targets ?write_targets))

  (test (< (send ?obj fraction
                 (sym-cat (send ?obj uniformity-key) "-" ?mount_point
                          "-write_targets")
                 ?write_targets) 0.9))

  =>

  (bind ?fraction
        (* 100 (send ?obj fraction
                     (sym-cat (send ?obj uniformity-key) "-" ?mount_point
                              "-write_targets")
                     ?write_targets)))


  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (- 100 ?fraction)) (severity 70) (source ?obj)
                 (state observed) (value TRUE)
                 (id "lustre-write-targets-uniform")
                 (args (create$ ?mount_point ?fraction ?write_targets))))

