; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule all-mem-channels
  "Check that the all memory channels are being used on every CPU."
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?cpu <- (object (is-a CPU) (node_id ?node) (cpu-type xeon_scalable))
  ?obj <- (object (is-a MEMORY)
    (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role))
    (node_id ?node) (min-dimms-per-socket ?mdps))
  (test (< ?mdps 6))
  =>
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 90)
    (state observed)
    (value TRUE)
    (id "all-mem-channels")
    (remedy "all-mem-channels-remedy")
    (args ?node ?mdps)
  )
)
