; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule dimms-per-socket-not-uniform
  "Uniformity for the dimms installed per socket"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node) (dimm-count ?dcount&~0) (dimms-per-socket $? ?dps $?))
  ?cpu <- (object (is-a CPU) (node_id ?node) (cpu-type xeon_scalable) (sockets ?sockets&~0))
  (test(< (multiset-fraction (send ?obj node-based-uniformity-key DIMMPS) ?dps) 1.0))
  (test(= (mod ?dps 2) 0))
  (not (object (is-a SIGN) (node_id ?node) (id "dimms-per-socket-not-uniform")))
  =>
  (bind ?severity 10)
  (bind ?id "dimms-per-socket-not-uniform")
  (bind ?remedy "dimms-per-socket-not-uniform-remedy")
  ; create a sign only if know that sockets are balanced.
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 75) (severity ?severity)
                 (state observed) (source ?obj) (value TRUE)
                 (id ?id)
                 (remedy ?remedy)
                 (args (create$ ?dps ?dcount ?sockets))))

