; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule dmidecode-data-error
  "Check that dmidecode data is available or unparsaeble."
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?cpu <- (object (is-a CPU) (node_id ?node) (cpu-type xeon_scalable))
  ?obj <- (object (is-a MEMORY) (node_id ?node)
                             (dmidecode-err ?derr&:(neq (str-compare ?derr "data-missing") 0))
                             (dmidecode-path-err ?dperr&:(neq (str-compare ?dperr "CLCK_LOCATION_NOT_FOUND") 0))
                             (min-dimms-per-socket ?mdps)
                             (dimm-count ?dcount)
                             (max-dimm-count ?mdcount)
                             (dimm-indices $?di)
                             (dimm-sizes $?dsi)
                             (dimm-speeds $?dsp)
                             (dimm-form-factors $?dff)
                             (dimm-types $?dt)
                             (dimm-locators $?dl)
                             (dimms-per-socket $?dps))
  (test (or (> (str-length ?derr) 0)
            (= ?mdcount 0)
            (= ?dcount 0)
            (!= ?mdcount (length ?di) (length ?dsi) (length ?dsp) (length ?dff) (length ?dt) (length ?dl))
            (= (length ?dps) 0)
            (= ?mdps 0)))
  =>
  (bind ?id "dmidecode-data-error")
  (bind ?remedy "dmidecode-data-error-remedy")
  (if (= (str-compare ?derr "Insufficient Privileges") 0) then
    (bind ?id "dmidecode-insufficient-privileges")
    (bind ?remedy "dmidecode-data-error-remedy"))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 0)
                 (state observed) (value TRUE) (source ?obj)
                 (id ?id)
                 (remedy ?remedy)))
