; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule dmidecode-data-missing
  "Check that dmidecode data is missing."
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?cpu <- (object (is-a CPU) (node_id ?node) (cpu-type xeon_scalable))
  ?obj <- (object (is-a MEMORY) (node_id ?node)
                             (dmidecode-err ?derr&:(= (str-compare ?derr "data-missing") 0)))
  =>
  (bind ?id "dmidecode-data-missing")
  (bind ?remedy "dmidecode-data-error-remedy")
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id ?id)
                 (remedy ?remedy)))
