; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule memory-data-is-too-old
  "Identify nodes where the most recent MEMORY data should be
   considered too old.  Too old is defined to mean no data
   from the last 7 days (604800 seconds)."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? memory $?) (data-age-threshold ?age-threshold))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (architecture x86_64) (node_id ?node) (timestamp ?t))
  (not (object (is-a SIGN) (node_id ?node) (id "memory-data-is-too-old")))
  (test (< ?t (- (now) ?age-threshold)))
  =>
  (bind ?age (round (- (now) ?t)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 90) (severity 25)
                 (state observed) (value TRUE) (source ?obj)
                 (id "memory-data-is-too-old")
                 (args (create$ ?age ?age-threshold))))
