; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule memory-minimum-required-compat-hpc-2018.0
  "Check that the amount of physical memory per core is >= 64 GiB"
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (architecture x86_64) (node_id ?node) (physical-total ?mem&~0)
                                (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (test (< ?mem 68719476736)) ;64 GiB == 68719476736 bytes
  =>
  (bind ?pval (perform_byte_conversion ?mem 1 0))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "memory-minimum-required-compat-hpc-2018.0")
                 (remedy "memory-minimum-required-remedy")
                 (args ?pval)))

