; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule memory-minimum-required-login-sdvis-cluster-2018.0
  "Check for a minimum of 192 gibibytes of total random acces memory per node,
   as required by the Intel HPC Platform Specification layer
   sdvis-cluster-2018.0."
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (architecture x86_64) (node_id ?node)
          (physical-total ?mem&~0) (role $?role))
  (test (or (member$ login ?role) (member$ head ?role)))
  (test (< ?mem 206158430208))
  =>
  (bind ?pval (perform_byte_conversion ?mem 1 0))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "memory-minimum-required-login-sdvis-cluster-2018.0")
                 (remedy "memory-minimum-required-remedy")
                 (args ?pval)))

