; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule memory-not-uniform
  "Check that the amount of physical memory is uniform."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? memory $?) (memory-uniformity-threshold ?threshold))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node) (physical-total ?mem&~0)
                  (statistics_control TRUE))
  (test (> (abs (- (send ?obj median (send ?obj statistics-key physical-total))
                   ?mem)) ?threshold))
  =>
  (bind ?median (send ?obj median (send ?obj statistics-key physical-total)))
  (bind ?severity (* (/ (abs (- ?median ?mem)) ?median) 80))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 75) (severity ?severity)
                 (state observed) (source ?obj) (value TRUE)
                 (id "memory-not-uniform")
                 (args (create$ ?mem ?median ?threshold))))

