; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule memory-speeds-not-uniform
  "Speeds of DIMMs installed not uinform"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node) (dimm-indices $? ?didx $?))
  ?cpu <- (object (is-a CPU) (node_id ?node) (cpu-type xeon_scalable))
  (test ( > (send ?obj get-dimm-size-by-idx ?didx) 0))
  (test ( < (multiset-fraction (send ?obj dimm-uniformity-key (send ?obj get-form-factor-by-idx ?didx) SPEED) (send ?obj get-dimm-speed-by-idx ?didx)) 1.0))
  (not (object (is-a SIGN) (node_id ?node)
                 (id "memory-speeds-not-uniform") (sub-id ?subid&:(= (str-compare ?subid (str-cat (send ?obj get-dimm-size-by-idx ?didx) ":" (send ?obj get-locator-by-idx ?didx))) 0))))
  =>
  (bind ?loc  (send ?obj get-locator-by-idx ?didx))
  (bind ?dff  (send ?obj get-form-factor-by-idx ?didx))
  (bind ?dspeed  (send ?obj get-dimm-speed-by-idx ?didx))
  (bind ?percent (* 100 (multiset-fraction (send ?obj dimm-uniformity-key ?dff SPEED) ?dspeed)))
  (bind ?severity 10)
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 75) (severity ?severity)
                 (state observed) (source ?obj) (value TRUE)
                 (id "memory-speeds-not-uniform") (sub-id (str-cat ?dspeed ":" ?loc))
                 (remedy "memory-speeds-not-uniform-remedy")
                 (args (create$ ?percent ?dspeed ?loc))))
