; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule min-mem-per-core-compute-sdvis-cluster-2018.0
  "Checks for a minimum of 2.5 gibibytes of random access memory per processor
   core, as required by the Intel HPC Platform Specification layer
   sdvis-cluster-2018.0."
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node)
    (physical-per-core ?physical-per-core) (role $?role))
  (test (or (member$ compute ?role) (member$ enhanced ?role)))
  (test (< ?physical-per-core 2684354560))
  =>
  (bind ?pval (perform_byte_conversion ?physical-per-core 1 0))
  (bind ?pvalr (perform_byte_conversion 2684354560 1 0))
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (severity 80)
    (state observed)
    (value TRUE)
    (id "min-mem-per-core-compute-sdvis-cluster-2018.0")
    (args ?pvalr ?pval)))
