; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule min-mem-per-node
  "Check that the amount of physical memory per node is >= 96 GiB."
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node)
    (physical-total ?mem&~0) ; measured in kB
    (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  ; if total memory (converted B -> GB) < 96 GB ...
  (test (< (/ ?mem 1e9) 96))
  =>
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 90)
    (state observed)
    (value TRUE)
    (id "min-mem-per-node")
    (remedy "min-mem-per-node-remedy")
    (args (/ ?mem 1e9) 96)
  )
)
