; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rhos-min-dimms-per-node-not-control
  "check that number of dimms is >= 8"
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  (object (is-a MEMORY) (node_id ?node)
    (role $?role&:(member$ application ?role)|:(member$ storage ?role))
    (dimm-count ?d_count)) ; number of dimms found
  ; if total memory (converted B -> GB)
  (test (< ?d_count 8))
  =>
  (bind ?count_expected 8)
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 90)
    (state observed)
    (value TRUE)
    (id "rhos-min-dimms-per-node")
    (remedy "rhos-min-dimms-node-remedy")
    (args (create$ ?d_count ?count_expected))
  )
)
