; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rhos-min-mem-per-dimm-not-control
  "Check that the amount of physical memory per dimm is >= 32GB"
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node)
    (role $?role&:(member$ application ?role)|:(member$ storage ?role))
    (dimm-indices $? ?didx $?)) ;indices
  ; if total memory (converted B -> GB)
  (not (object (is-a SIGN) (id "rhos-min-mem-per-dimm") (node_id ?node)))
  (test (and (< (send ?obj get-dimm-size-by-idx ?didx) 32)
             (eq (str-compare (send ?obj get-dimm-type-by-idx ?didx) DDR4) 0)))
  =>
  (bind ?size (send ?obj get-dimm-size-by-idx ?didx))
  (bind ?size_expected 32)
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 90)
    (state observed)
    (value TRUE)
    (source ?obj)
    (id "rhos-min-mem-per-dimm")
    (remedy "rhos-min-mem-per-dimm-remedy")
    (args (create$ ?size ?size_expected))
  )
)
