; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rhos-min-mem-per-node
  "Diagnose if memory per node does not meet min requirements."
  ?sign1 <- (object (is-a SIGN) (node_id ?node)
                    (id "rhos-min-mem-per-dimm")
                    (suppressed FALSE) (value TRUE))
  ?sign2 <- (object (is-a SIGN) (node_id ?node)
                    (id "rhos-min-dimms-per-node")
                    (suppressed FALSE) (value TRUE))
  =>
  (bind ?size (nth$ 1 (send ?sign1 get-args)))
  (bind ?size_expected (nth$ 2 (send ?sign1 get-args)))
  (bind ?d_count (nth$ 1 (send ?sign2 get-args)))
  (bind ?count_expected (nth$ 2 (send ?sign2 get-args)))

  ; the further apart the two data points in time, the lower the confidence
  (bind ?severity (combine-severity (send ?sign1 get-severity)
                                    (send ?sign2 get-severity)))

  (make-instance of DIAGNOSIS (node_id ?node)
                 (severity ?severity)
                 (id "rhos-min-mem-per-node")
                 (args (create$ (* ?size ?d_count)
                                (* ?size_expected ?count_expected)))
  )
  (modify-instance ?sign1 (state diagnosed))
  (modify-instance ?sign2 (state diagnosed))
)

