; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rhos-min-speed-per-dimm
  "Check that dimm speed of the dimm is >= 2400MHz"
  (object (is-a CONFIG) (name [config]) (clck-checks $? memory $?))
  (analyze-extension-done)
  ?obj <- (object (is-a MEMORY) (node_id ?node)
    (dimm-indices $? ?didx $?)) ;indices
  ; if total memory (converted B -> GB)
  (not (object (is-a SIGN) (id "rhos-min-speed-per-dimm") (node_id ?node)))
  ;speed in MHz
  (test (and (< (send ?obj get-dimm-speed-by-idx ?didx) 2400)
             (eq (str-compare (send ?obj get-dimm-type-by-idx ?didx) DDR4) 0)))
  =>
  (bind ?speed (send ?obj get-dimm-speed-by-idx ?didx))
  (bind ?speed_expected 2400)
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 90)
    (state observed)
    (value TRUE)
    (source ?obj)
    (id "rhos-min-speed-per-dimm")
    (remedy "rhos-min-speed-per-dimm-remedy")
    (args (create$ ?speed ?speed_expected))
  )
)
