; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mount-bad-tmp-perms
  "Check that /tmp has the permissions 777."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mount $?))
  ?obj <- (object (is-a MOUNT) (node_id ?node)
                  (tmp_perms ?perms) (tmp_path ?path))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (not (or (eq ?perms "0777") (eq ?perms "1777")
                 (eq ?perms "9876") (eq ?perms "777"))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "mount-bad-tmp-perms")
                 (args (create$ ?perms ?path))
                 (remedy "mount-bad-tmp-perms-remedy")))

