; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mount-dev-shm-not-mounted
  "Check that /dev/shm is properly mounted"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mount $?))
  ?obj <- (object (is-a MOUNT) (node_id ?node)
                  (dev_shm_mounted ?sm))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (eq ?sm 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 50)
                 (state observed) (source ?obj) (value TRUE)
                 (id "mount-dev-shm-not-mounted")
                 (remedy "mount-dev-shm-not-mounted-remedy")))

