; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mount-home-wrong-path
  "HOME environment variable is not defined as per the Intel HPC Platform
   Specification."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mount $?))
  ?obj <- (object (is-a MOUNT) (node_id ?node) (home_path ?home_path) (pwd ?pwd))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (not (object (is-a SIGN) (node_id ?node) (id "mount-home-not-defined")))
  (test (!= (str-compare ?home_path ?pwd) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (args ?home_path)
                 (severity 70) (state observed) (source ?obj) (value TRUE)
                 (id "mount-home-wrong-path")))
