; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mount-not-uniform-home-inode
  "Check that the home path is shared on the cluster by checking the
   uniformity of the inodes of the home directory."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mount $?))
  ?obj <- (object (is-a MOUNT) (node_id ?node)
                  (multiset_control TRUE)
                  (home_inode ?home_inode&:(and (!= (str-length ?home_inode) 0)
                                                (not (eq ?home_inode "00009876"))))
                  (home_path ?path&:(!=(str-length ?path) 0)))
  (test (< (send ?obj fraction (sym-cat (send ?obj uniformity-key) -home_inode)
                 ?home_inode) 0.9))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  =>
  (bind ?fraction (* 100 (send ?obj fraction
                               (sym-cat (send ?obj uniformity-key) -home_inode)
                               ?home_inode)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (- 100 ?fraction)) (severity 70) (source ?obj)
                 (state observed) (value TRUE)
                 (id "mount-not-uniform-home-inode")
                 (args (create$ ?fraction ?home_inode ?path))
                 (remedy "mount-not-uniform-home-inode-remedy")
                 (remedy-args ?path)))

