; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mount-tmpdir-not-fully-qualified-pathname
  "TMPDIR environment variable is not a fully qualified pathname"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mount $?))
  ?obj <- (object (is-a MOUNT) (node_id ?node)
                  (tmp_path ?path))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (not (object (is-a SIGN) (node_id ?node) (id "mount-tmpdir-not-defined")))
  (test (neq (str-index "/" ?path) 1))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (args ?path)
                 (severity 70) (state observed) (source ?obj) (value TRUE)
                 (id "mount-tmpdir-not-fully-qualified-pathname")))

