; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mount-tmpdir-not-unique
  "Check that the value of $TMPDIR is unique on every node."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mount $?))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (analyze-extension-done)
  ?obj <- (object (is-a MOUNT) (node_id ?node) (filesystem $? ?filesystem $?)
                  (local-systems $?local) (tmp_path ?tmp))
  (test (not (member$ ?filesystem ?local)))
  (test (neq (send ?obj multiplicity (sym-cat (send ?obj uniformity-key-basic) -tmp_path) ?tmp)
             1))
  =>
  (bind ?fraction (send ?obj fraction (sym-cat (send ?obj uniformity-key-basic) -tmp_path) ?tmp))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 70) (source ?obj)
                 (state observed) (value TRUE) (id "mount-tmpdir-not-unique")
                 (args (create$ ?tmp))))
