; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mpi-internode-broken
  "Check whether MPI intra node 'Hello World' is functional."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mpi_internode $?))
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  ?obj <- (object (is-a MPI_INTERNODE) (node_id ?node) (status FAIL))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (state observed) (source ?obj) (value TRUE)
                 (id "mpi-internode-broken")
                 (sub-id (str-cat (send ?obj get-i_mpi_fabrics)))
                 (args (send ?obj get-impi-setting-string))))

