; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mpi-local-broken
  "Identify cases where there are less than 4 lines of valid output in
   the parsed output, but a mpirun binary executable was found"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mpi_local $?))
  ?obj <- (object (is-a MPI_LOCAL) (latest-timestamp TRUE) (node_id ?node)
                  (valid_lines ?valid) (mpi_path ?p))
  (object (is-a NODE) (node_id ?node))
  (test (!= ?valid 4))
  (test (> (str-length ?p) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (source ?obj) (state observed) (value TRUE)
                 (id "mpi-local-broken")))

