; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mpi-local-path-not-uniform
  "If the mpi-local-path found on each node is not the same as atleast
   90% of the other nodes, then the node should be flagged as
   non-uniform. The fewer other nodes that have the same
   mpi-local-path increase the confidence that the node with the
   different version is incorrect"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? mpi_local $?))
  ?obj <- (object (is-a MPI_LOCAL) (latest-timestamp TRUE) (node_id ?node)
                  (mpi_path ?p&:(> (str-length ?p) 0)) (multiset_control TRUE))
  (object (is-a NODE) (node_id ?node))
  (test (< (send ?obj fraction (send ?obj uniformity-key) ?p) 0.9))
  =>
  (bind ?percent (* 100 (send ?obj fraction (send ?obj uniformity-key) ?p)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 60) (source ?obj)
                 (confidence (- 100 ?percent)) (state observed) (value TRUE)
                 (id "mpi-local-path-not-uniform")
                 (args (create$ ?percent ?p))))

