; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule only-four-nodes-required
  "Tests if there are more or less than 4 nodes on the cluster"
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config]))
  (not (object (is-a SIGN) (id "number_of_nodes_required")))
  (test (not (= (number-of (find-all-instances ((?n NODE)) (is-compute ?n:role))) 4)))
  =>
  (bind ?expected 4)
  (bind ?nodes (find-all-instances ((?n NODE)) (is-compute ?n:role)))
  (bind ?node_number (number-of ?nodes))
  (make-instance of BOOLEAN_SIGN
  (severity 90)
  (state observed)
  (value TRUE)
  (node_id (cat-node-name-of ?nodes))
  (id "number_of_nodes_required")
  (args (create$ ?node_number ?expected))
  )
)

