; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ntp-not-connected
  "Check if ntp client is not connected to an ntp server.  This is true
   if the remote slot is set to the default"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ntp $?))
  ?obj <- (object (is-a NTP) (node_id ?node)
                  (remote ?remote&:(= (str-length ?remote) 0)))
  (object (is-a NODE) (node_id ?node))
  =>
  (make-instance of BOOLEAN_SIGN
                 (node_id ?node) (confidence 30) (severity 50)
                 (state observed) (value TRUE) (source ?obj)
                 (id "ntp-not-connected")))

