; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ntp-offset-above-threshold
  "Check if reported time offset is larger than a threshold.
   Increase severity based on the size of the difference between the
   offset and threshold."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ntp $?) (ntp-offset-threshold ?thresh))
  ?obj <- (object (is-a NTP) (node_id ?node) (remote ?remote) (offset ?offset))
  (object (is-a NODE) (node_id ?node))
  (test (> (abs ?offset) ?thresh))
  =>
  (bind ?severity (* (- 1 (gaussian (abs ?offset) ?thresh
                                    (/ (abs ?offset) 2))) 50))
  (make-instance of BOOLEAN_SIGN
                 (node_id ?node) (confidence 20) (severity ?severity)
                 (state observed) (value TRUE) (source ?obj)
                 (args (create$ ?remote ?offset ?thresh))
                 (id "ntp-offset-above-threshold")))

