; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule opa-data-missing
  "Identify instances of missing Intel(R) Omni-Path Host Fabric Interface
   information."
  (object (is-a CONFIG) (name [config])(clck-checks $? opa $?))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (object (is-a OPA_PCI_DEVICE) (node_id ?node))
  (not (object (is-a SIGN) (id "opa-data-missing") (node_id ?node)))
  (or (not (object (is-a OPA_CONFIG) (node_id ?node)))
      (not (object (is-a OPA_HFI_INFO) (node_id ?node)))
      (not (object (is-a OPA_FW_VER) (node_id ?node))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70)
                 (state observed) (value TRUE)
                 (id "opa-data-missing")
                 (remedy "opa-data-missing-remedy")))

