; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule opa-firmware-version-is-not-consistent
  "Identify inconsistent Intel(R) Omni-Path Host Fabric Interface firmware
   versions."
  (object (is-a CONFIG) (name [config]) (clck-checks $? opa $?))
  (analyze-extension-done)
  ?obj <- (object (is-a OPA_FW_VER) (node_id ?node) (fw_ver $? ?v $?))
  (test (< (send ?obj fraction (send ?obj uniformity-key fw_ver) ?v) 0.9))
  =>
  (bind ?percent (* 100 (send ?obj fraction
                              (send ?obj uniformity-key fw_ver) ?v)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 50)
                 (state observed) (source ?obj) (value TRUE)
                 (id "opa-firmware-version-is-not-consistent")
                 (args (create$ ?v ?percent))))

