; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule opa-regex-error
  "If the analyze extension regex fails to parse any of the
   Intel(R) Omni-Path Host Fabric Interface commands this error
   should fire notifying the user of the issue."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? opa $?))
  ?obj <- (object (is-a OPA_HFI_INFO) (node_id ?node) (error ?err))
  (object (is-a NODE) (node_id ?node))
  (test (> (str-length ?err) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 70) (source ?obj)
                 (state observed) (value TRUE) (id "opa-regex-error")
                 (args ?err)))
