; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule opa-state-is-not-consistent
  "Identify inconsistent Intel(R) Omni-Path Host Fabric Interface states."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? opa $?))
  ?obj <- (object (is-a OPA_HFI_INFO) (error ?err) (state ?s)
                  (multiset_control TRUE) (node_id ?node))
  (object (is-a NODE) (node_id ?node))
  (not (object (is-a SIGN) (node_id ?node) (id "opa-regex-error")))
  (test (= (str-length ?err) 0))
  (test (< (send ?obj fraction (send ?obj multiset-key state) ?s)
           0.9))
  =>
  (bind ?key (send ?obj multiset-key state))
  (bind ?fraction (- 1 (send ?obj fraction ?key ?s)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence (* 100 ?fraction)) (severity 70)
                 (state observed) (source ?obj) (value TRUE)
                 (id "opa-state-is-not-consistent")
                 (sub-id (str-cat (send ?obj get-ca) - (send ?obj get-port)))
                 (args (create$
                        (send ?obj get-ca)
                        (send ?obj get-port)
                        (* 100 (send ?obj fraction ?key ?s))
                        ?s))))

