; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule opa-subnet-manager-not-running
  "Identify an Intel(R) Omni-Path subnet manager is running for Intel(R) Omni-Path Fabric."
  (object (is-a CONFIG) (name [config]) (clck-checks $? opa $?))
  (object (is-a OPA_PCI_DEVICE) (node_id ?node))
  ?obj <- (object (is-a SAQUERY_INFO) (node_id ?node)
                  (class_version ?class_version))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (test (!= ?class_version 128))
  (not (object (is-a SIGN) (id "missing-saquery-tool") (node_id ?node)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 90)
                 (severity 80) (state observed) (source ?obj) (value TRUE)
                 (id "opa-subnet-manager-not-running")
                 (args ?class_version)
                 (remedy "opa-subnet-manager-not-running-remedy")))

