; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule perl-not-core-intel-runtime-2018.0
  "If the Perl version is less than 5.16, then Perl is not compliant with
  Intel HPC Platform Specification layer core-intel-runtime-2018.0."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? perl $?))
  ?obj <- (object (is-a PERL) (latest-timestamp TRUE) (node_id ?hostname)
                  (version ?ver&:(!= (str-length ?ver) 0)))
  (object (is-a NODE) (node_id ?hostname))
  (test (< (vercmp ?ver "5.16") 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (severity 80) (source ?obj) (state observed) (value TRUE)
                 (id "perl-not-core-intel-runtime-2018.0")
                 (args (create$ ?ver "5.16"))))

