; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule process-is-high-cpu
  "For the most recent PROCESS data point, identify nodes with high
   cpu processes, i.e., processes using more than 20% of a cpu core."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? process $?))
  ?obj <- (object (is-a PROCESS) (node_id ?node)
                  (latest-timestamp TRUE) (pcpu ?pcpu) (pid ?pid)
                  (timestamp ?t) (uid ?uid) (username ?uname)
                  (cmd ?command))
  (object (is-a NODE) (node_id ?node))
  (test (> ?pcpu 20))
  =>
  ; the higher the cpu percentage, the higher the severity
  (bind ?severity (min 100 ?pcpu))
  (make-instance of BOOLEAN_SIGN
                 (node_id ?node) (confidence 90) (severity ?severity)
                 (state observed) (value TRUE) (source ?obj)
                 (id "process-is-high-cpu") (sub-id (str-cat ?command))
                 (args (create$ ?command ?uname ?pcpu ?pid))
                 (remedy "process-is-high-cpu-remedy")))

