; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule missing-tool-core-intel-runtime-2018.0
  "Checks for the following list of tools:
    ANSI* standard C/C++ language runtime of the GNU* C Compiler
    ANSI* standard C/C++ language runtime of the Intel(R) C++ Compiler
    Standard Fortran language runtime of the Intel(R) Fortran Compiler
    Intel(R) Math Kernel Library
    Intel(R) Threading Building Blocks
    Intel(R) MPI Library Runtime Environment
    The Intel(R) Distribution for Python* scripting language"
  (declare (salience ?*high-salience*))
  (object (is-a CONFIG) (name [config])
          (clck-checks $? psxe_versions $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a PSXE_VERSIONS) (node_id ?n)
                   (toolnames $?tools) (req-tools $? ?req $?))
  (test (not (member$ ?req ?tools)))
  =>
  (bind ?remedy "missing-tool-core-intel-runtime-2018.0-remedy")
  (if (or (eq (str-compare ?req "python2") 0)
          (eq (str-compare ?req "python3") 0))
      then (bind ?remedy "intel-python-missing-remedy"))
  (bind ?toolname (send ?obj get-tool-string ?req))
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 75)
                 (value TRUE) (state observed) (source ?obj)
                 (id "missing-tool-core-intel-runtime-2018.0") (sub-id ?req)
                 (args ?toolname) (remedy ?remedy)))

