; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule psxe-library-2018-not-x86-64
  "Check for all libraries required for Intel(R) Parallel Studio 2018 with
   architecture x86-64."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? psxe_versions $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj1 <- (object (is-a LDCONFIG) (node_id ?n)
                  (libraries $?libraries) (psxe-2018-libraries $? ?req $?))
  ?obj2 <- (object (is-a PSXE_VERSIONS) (node_id ?n)
                   (toolnames $?tools))
  (not (object (is-a SIGN) (node_id ?n) (id "missing-tool-core-intel-runtime-2018.0")))
  (test (member$ mpi ?tools))
  (test (eq (str-compare (send ?obj2 get-version mpi) "2018") 0))
  (test (member$ ?req ?libraries))
  (test (!= (str-compare (send ?obj1 find-arch ?req) "x86-64") 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 75)
                 (value TRUE) (state observed) (source ?obj1)
                 (id "psxe-library-2018-not-x86-64") (args ?req)))

