; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule psxe_versions-data-is-too-old
  "Identify nodes where the most recent PSXE_VERSIONS data should be
   considered too old., Too old is defined to mean no data
   from the last 7 days (604800 seconds)."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? psxe_versions $?) (data-age-threshold ?age-threshold))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  ?obj <- (object (is-a PSXE_VERSIONS) (node_id ?node) (timestamp ?t))
  (not (object (is-a SIGN) (node_id ?node) (id "psxe_versions-data-is-too-old")))
  (test (< ?t (- (now) ?age-threshold)))
  =>
  (bind ?age (round (- (now) ?t)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 75)
                 (state observed) (value TRUE) (source ?obj)
                 (id "psxe_versions-data-is-too-old")
                 (args (create$ ?age ?age-threshold))))


