; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule tool-version-not-minimum-core-intel-runtime-2018.0
  "Checks for the following list of tools:
    ANSI* standard C/C++ language runtime of the GNU* C Compiler version 4.8 or
      later
    ANSI* standard C/C++ language runtime of the Intel(R) C++ Compiler version
      18.0 or later
    Standard Fortran language runtime of the Intel(R) Fortran Compiler version
      18.0 or later
    Intel(R) Math Kernel Library version 2018.0 or later
    Intel(R) Threading Building Blocks version 2018 or later
    Intel(R) MPI Library Runtime Environment version 2018 or later
    The Intel(R) Distribution for Python* scripting language version 2018 or
      later"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? psxe_versions $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a PSXE_VERSIONS) (node_id ?n)
                   (toolnames $?tools) (req-tools $? ?req $?))
  (test (and (member$ ?req ?tools)
             (neq (str-compare (send ?obj get-version ?req) "none") 0)
             (neq (str-compare (send ?obj get-version ?req) "invalid") 0)
             (or (= (str-length (send ?obj get-version ?req)) 0)
                 (< (vercmp (send ?obj get-version ?req)
                            (send ?obj get-req-version ?req)) 0))))
  =>
  (bind ?ver (send ?obj get-version ?req))
  (bind ?reqver (send ?obj get-req-version ?req))
  (bind ?toolname (send ?obj get-tool-string ?req))
  (bind ?id "tool-version-not-minimum-core-intel-runtime-2018.0")
  (if (eq (str-compare ?req "gxx") 0) then
    (bind ?id "gxx-version-not-minimum-core-intel-runtime-2018.0"))
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 75)
                 (value TRUE) (state observed) (source ?obj)
                 (id ?id) (sub-id ?req)
                 (args ?toolname ?ver ?reqver)))
