; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule python-not-found
  "If no Python version is found and stderr contains the string
  'command not found', then Python is not installed / incorrectly
  installed."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? python $?))
  ?obj <- (object (is-a PYTHON) (latest-timestamp TRUE) (node_id ?hostname)
                  (stderr ?err) (version ?ver))
  (object (is-a NODE) (node_id ?hostname))
  (test (and (= (str-length ?ver) 0) (str-index "command not found" ?err)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 90) (severity 70) (source ?obj)
                 (state observed) (value TRUE) (id "python-not-found")))

