; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule python-not-functional
  "If no Python version is present or stderr is not empty, then Python
   may not be functional.  If a version is present and stderr is not
   empty, use lower confidence and severity values, since the stderr
   output may be unrelated.  If no version is present and stderr is
   not empty, then Python is definitely not functional, so use high
   confidence and severity values.  Avoid matching the 'command not
   found' case that is handled separately."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? python $?))
  ?obj <- (object (is-a PYTHON) (latest-timestamp TRUE) (node_id ?hostname)
                  (stderr ?err) (version ?ver))
  (object (is-a NODE) (node_id ?hostname))
  (not (object (is-a SIGN) (id "python-not-found") (source ?obj)))
  (test (or (= (str-length ?ver) 0) (!= (str-length ?err) 0)))
  =>
  (if (> (str-length ?ver) 0)
      then (bind ?confidence 25)  (bind ?severity 25)
      else (bind ?confidence 90) (bind ?severity 60))
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence ?confidence) (severity ?severity) (source ?obj)
                 (state observed) (value TRUE) (id "python-not-functional")
                 (args ?err)))

