; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule missing-rhos-tools
  "Tools used for various checks with the Red Hat Openshift Solution."
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? rhostools $?))
  ?obj <- (object (is-a RHOS-TOOLS) (node_id ?n)
                  (toolnames $?toolnames) (req-tools $? ?tool $?))
  (test (not (member$ ?tool ?toolnames)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (confidence 90) (severity 90)
                 (value TRUE) (state observed) (source ?obj)
                 (id "missing-rhos-common-tool") (sub-id ?tool) (args ?tool)
                 (remedy "missing-rhos-common-tool-remedy")
                 (remedy-args ?tool)))
