; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule min-nodes-per-role-expected-storage
  "Check that the number of nodes is minimally the number of expected nodes."
  (analyze-extension-done)
  ?obj <-(object (is-a ROLES-storage) (node-count-storage ?node-count)
         (role-name ?role-name) (expected-node-count-storage ?exp-node-count) )
  (test (< ?node-count ?exp-node-count))
  =>
  (make-instance of BOOLEAN_SIGN
    (node_id (send ?obj get-node_id))
    (confidence 90)
    (severity 90)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "min-nodes-per-role-expected-storage")
    (args (create$ ?role-name ?node-count ?exp-node-count))
  )
)
