; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule infiniband-diags-version-not-minimum
  "Checks whether each node includes the infiniband-diags package version 13 or
   greater, as required by the Intel HPC Platform Specification 
   layer high-performance-fabric-2018.0."
  (object (is-a CONFIG) (name [config]) (clck-checks $? rpm $?))
  (object (is-a NODE) (node_id ?node) (role $?role))
  (analyze-extension-done)
  ?obj <- (object (is-a RPM) (node_id ?node) (names $?rpms))
  (test (neq (member$ infiniband-diags ?rpms) FALSE))
  (test
    (or (= (str-length (send ?obj find-version infiniband-diags)) 0)
        (< (vercmp (send ?obj find-version infiniband-diags)
                   "1.6.4") 0)))
  =>
  (bind ?ver (send ?obj find-version infiniband-diags))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 80) (source ?obj)
                 (state observed) (value TRUE) (id "infiniband-diags-version-not-minimum")
                 (args (create$ ?ver))))
