; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule libfabric-version-not-minimum
  "Checks whether each node includes the OpenFabric Interfaces (OFI) libfabric
   package version 1.4.0 or greater, as required by the Intel HPC Platform
   Specification layer high-performance-fabric-2018.0."
  (declare (salience ?*low-salience*))
  (object (is-a CONFIG) (name [config]) (clck-checks $? rpm $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node) (role $?role))
  ?obj <- (object (is-a RPM) (node_id ?node) (names $?rpms))
  (test (member$ libfabric ?rpms))
  (test
    (or (= (str-length (send ?obj find-version libfabric)) 0)
        (< (vercmp (send ?obj find-version libfabric)
                   "1.4.0") 0)))
  =>
  (bind ?ver (send ?obj find-version libfabric))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 80) (source ?obj)
                 (state observed) (value TRUE) (id "libfabric-version-not-minimum")
                 (args (create$ ?ver))))
