; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rpm-is-extra
  "Check whether an RPM is present on this node, but missing on other nodes."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? rpm $?) (rpm-uniformity-threshold ?threshold))
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(and (or (member$ compute ?role)
                                 (member$ enhanced ?role))
                             (not (member$ head ?role)))))
  (analyze-extension-done)
  ?obj <- (object (is-a RPM) (node_id ?node) (rpms $? ?rpm $?))
  (test (eq (send ?obj find-state ?rpm) extra))
  (test (<= (multiset-fraction (send ?obj uniformity-key ?rpm) extra)
            ?threshold))
  =>
  (bind ?percent (* 100 (multiset-fraction
                         (send ?obj uniformity-key ?rpm) extra)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence (- 100 ?percent))
                 (severity 30) (source ?obj) (state observed) (value TRUE)
                 (id "rpm-is-extra") (sub-id (str-cat ?rpm))
                 (args (create$ ?rpm))))

