; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule rpm-extra
  "Check if RPM has information has changed(extra rpm) between the snapshots."
  (object (is-a CONFIG) (name [config]) (clck-checks $? rpm_baseline $?))
  ?obj <- (object (is-a RPM_BASELINE)
    (node_id  ?node)     ; host in question
    (rpm_name ?rpm_name) ; rpm in question
    (rpm_version ?rpm_version)
    (rpm_release ?rpm_release)
    (rpm_arch ?rpm_arch)
    (status  ?status)   ; added since initial snapshot
  )
  (object (is-a NODE) (node_id ?node))

  (test (= (str-compare ?status "extra") 0))
  =>
  ; FIRE!
  (make-instance of BOOLEAN_SIGN
    (node_id ?node)
    (confidence 90)
    (severity 15)
    (state observed)
    (source ?obj)
    (value TRUE)
    (id "rpm-extra")
    (args (create$ ?node ?rpm_name ?rpm_version ?rpm_release ?rpm_arch))
  )
)
