; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule saquery-missing
  "Check whether saquery is missing."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? saquery $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a SAQUERY_INFO) (node_id ?n)
                  (toolnames $?toolnames))
  (test (not (member$ saquery ?toolnames)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 70)
                 (value TRUE) (state observed) (source ?obj) (args "saquery")
                 (id "saquery-missing")))

