; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule mesa-version-not-minimum
  "checking of missing tools install for sdviz"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? sdvis_tools $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a SDVIS-TOOL-SET) (node_id ?n)
           (toolnames $?toolnames) (req-tools $? mesa $?))
  (test (and (member$ mesa ?toolnames)
             (neq (send ?obj get-version mesa) none)
             (eq (vercmp (send ?obj get-version mesa)
                         (send ?obj get-req-version mesa))
                         -1)))
  =>
  (bind ?id "mesa-version-not-minimum")
  (bind ?ver (send ?obj get-version mesa))
  (bind ?rver (send ?obj get-req-version mesa))
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 75) (value TRUE) (state observed)
                 (source ?obj)
                 (args (create$ ?ver ?rver))
                 (id ?id)))
