; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule vtk-missing
  "checking of missing tools install for sdviz"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? sdvis_tools $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?n) (architecture x86_64))
  ?obj <- (object (is-a SDVIS-TOOL-SET) (node_id ?n)
          (toolnames $?vtknames)(req-tools $? vtk $?))
  (test (or (not (member$ vtk ?vtknames))
            (and (member$ vtk ?vtknames)
                 (eq (send ?obj get-version vtk) none))))
  =>
  (bind ?id "vtk-missing")
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (severity 75) (value TRUE) (state observed) (source ?obj)
                 (id ?id)))

