; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule invalid-services-specification
  "Identifies if the preferred services specifications are given in the
   right format."
  (object (is-a CONFIG) (name [config]) (clck-checks  $? services_status $?)
                        (preferred-services-status $? ?load-serv $?))
  (analyze-extension-done)
  (test (> (str-length ?load-serv) 0))
  ; sanity check (bad input)
  (test (neq (length$ (tokenize "|" ?load-serv)) 5))
  =>
  (make-instance of BOOLEAN_SIGN
                 (confidence 90) (severity 40)
                 (state observed) (value TRUE)
                 (id "invalid-services-specification")
                 (remedy "invalid-services-specification-remedy")
                 (args (create$ ?load-serv))))
