; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule service-not-available
  "Identifies if the required services are available on the node."
  (object (is-a CONFIG) (name [config]) (clck-checks  $? services_status $?)
                        (preferred-services-status $? ?load-serv $?))
  (analyze-extension-done)
  ?obj<-(object (is-a SYSCTL_STATUS) (node_id ?node) (role $? ?role $?)
                                              (service-names $?snames&:(> (length$ ?snames) 0)))
  ; sanity check
  (test (= (length$ (tokenize "|" ?load-serv)) 5))
  ; role applicable ?
  (test (= (str-compare (nth$ 2 (tokenize "|" ?load-serv)) ?role) 0))
  ; is the service even on the system
  (test (eq (member$ (nth$ 1 (tokenize "|" ?load-serv)) ?snames) FALSE))
  =>
  (bind ?serve-name (nth$ 1 (tokenize "|" ?load-serv)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 40)
                 (state observed) (source ?obj) (value TRUE)
                 (id "service-not-available") (sub-id (str-cat ?serve-name))
                 (remedy "service-not-available-remedy")
                 (remedy-args (create$ ?serve-name))
                 (args (create$ ?serve-name))))
