; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule services-data-missing
  "Identifies the nodes not having the services status data."
  (object (is-a CONFIG) (name [config]) (clck-checks  $? services_status $?))
  (analyze-extension-done)
  (object (is-a NODE) (node_id ?node))
  (not (object (is-a SYSCTL_STATUS) (node_id ?node)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 40)
                 (state observed) (value TRUE)
                 (id "services-data-missing")
                 (remedy "services-data-missing-remedy")))
