; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule services-preferred-status
  "Identifies if the services status match the given preferred specification"
  (object (is-a CONFIG) (name [config]) (clck-checks  $? services_status $?)
                        (preferred-services-status $? ?load-serv $?))
  (analyze-extension-done)
  ?obj<-(object (is-a SYSCTL_STATUS) (node_id ?node) (role $? ?role $?)
                                              (service-names $?snames&:(> (length$ ?snames) 0)))
  (test (= (length$ (tokenize "|" ?load-serv)) 5))
  ; role applicable ?
  (test (= (str-compare (nth$ 2 (tokenize "|" ?load-serv)) ?role) 0))
  ; is the service even on the system
  (test (member$ (nth$ 1 (tokenize "|" ?load-serv)) ?snames))
  ; check stats
  (test (or
            (neq (str-compare (str-cat (nth$ 2 (tokenize "|" ?load-serv)) "." (nth$ 3 (tokenize "|" ?load-serv))) (str-cat ?role "." (send ?obj get-load-state (nth$ 1 (tokenize "|" ?load-serv))))) 0)
            (neq (str-compare (str-cat (nth$ 2 (tokenize "|" ?load-serv)) "." (nth$ 4 (tokenize "|" ?load-serv))) (str-cat ?role "." (send ?obj get-active-state (nth$ 1 (tokenize "|" ?load-serv))))) 0)
            (neq (str-compare (str-cat (nth$ 2 (tokenize "|" ?load-serv)) "." (nth$ 5 (tokenize "|" ?load-serv))) (str-cat ?role "." (send ?obj get-sub-state (nth$ 1 (tokenize "|" ?load-serv))))) 0)
        )
  )
  =>
  (bind ?serve-name (nth$ 1 (tokenize "|" ?load-serv)))
  (bind ?load-stat (send ?obj get-load-state ?serve-name))
  (bind ?act-stat (send ?obj get-active-state ?serve-name))
  (bind ?sub-stat (send ?obj get-sub-state ?serve-name))
  (bind ?pload-stat (nth$ 3 (tokenize "|" ?load-serv)))
  (bind ?pact-stat  (nth$ 4 (tokenize "|" ?load-serv)))
  (bind ?psub-stat  (nth$ 5 (tokenize "|" ?load-serv)))
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 40)
                 (state observed) (source ?obj) (value TRUE)
                 (id "services-preferred-status") (sub-id (str-cat ?serve-name))
                 (remedy "services-preferred-status-remedy")
                 (args (create$ ?serve-name ?load-stat ?act-stat ?sub-stat ?pload-stat ?pact-stat ?psub-stat))))

