; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule invalid-sgemm-data
  "Detect cases where the SGEMM data is invalid, i.e., data provider
   output exists in the database, but the analyze extension could not parse
   it."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? sgemm $?))

  ?obj <- (object (is-a SGEMM) (node_id ?node) (flops 0))

  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id (send ?obj get-node_id))
                 (confidence 60) (severity 70) (state observed) (source ?obj)
                 (value TRUE) (id "invalid-sgemm-data")))
