; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule sgemm-numactl-missing
  "Checks if the numactl was not found. If this binary is not installed
   then sgemm performance may be affected."
  (object (is-a CONFIG) (name [config])
	  (clck-checks $? sgemm $?))
  (object (is-a CPU) (node_id ?node) (vendor-id "GenuineIntel")
	  (cpu-type ?cputype))
  (test (cpu-test ?cputype "xeonphi"))
  ?obj <- (object (is-a SGEMM) (node_id ?node) (numactl ?numa))
  (object (is-a NODE) (node_id ?node)
	  (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role))
	  (subcluster ?subcluster))
  (test (or (eq (str-compare ?numa "CLCK_LOCATION_NOT_FOUND") 0)
        (eq (str-compare ?numa "unknown") 0)))

  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
		 (confidence 75) (severity 50)
		 (state observed) (source ?obj)
		 (id "sgemm-numactl-missing")
		 (source ?obj) (value TRUE)))
