; Copyright 2017-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule sgemm-taskset-missing
  "Checks if the taskset binary was not found. If this binary is not installed
   then sgeem performance may be affected."
  (object (is-a CONFIG) (name [config])
	  (clck-checks $? sgemm $?))

  ?obj <- (object (is-a SGEMM) (node_id ?node) (taskset ?task))

  (object (is-a NODE) (node_id ?node)
	  (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role))
	  (subcluster ?subcluster))

  (test (or (eq (str-compare ?task "CLCK_LOCATION_NOT_FOUND") 0)
        (eq (str-compare ?task "unknown") 0)))

  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
		 (confidence 75) (severity 50)
		 (state observed) (source ?obj)
		 (id "sgemm-taskset-missing")
		 (source ?obj) (value TRUE)))
