; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ssf-file-other-error
  "If no Intel(R) Scalable System Framework versions are found or stderr is not
   empty, then the file may not be readable.  If a version is present
   and stderr is not empty, use lower confidence and severity values,
   since the stderr output may be unrelated.  If no version is present
   and stderr is not empty, then the file is definitely not readable,
   so use high confidence and severity values.  Avoid matching the 'No
   such file or directory' case that is handled separately."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? ssf_version $?))
  ?obj <- (object (is-a SSF) (node_id ?node)
                  (stderr ?err) (latest-timestamp TRUE))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (not (object (is-a SIGN) (id "ssf-file-not-found") (source ?obj)))
  (test (!= (str-length ?err) 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 80) (source ?obj)
                 (state observed) (value TRUE) (id "ssf-file-other-error")
                 (remedy "ssf-file-error-remedy")
                 (args ?err)))

