; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ssf-layer-compat-base-2016.0
  "Checks whether the required string compat-base-2016.0 is included in
   /etc/ssf-release."
  (object (is-a CONFIG) (name [config]) (ssf-layer ?layer)
          (clck-checks $? ssf_version $?))
  ?obj <- (object (is-a SSF) (node_id ?node)
                  (layer $?ssf-layer) (stderr ?err) (latest-timestamp TRUE))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (not (object (is-a SIGN) (node_id ?node) (id "ssf-file-not-found")))
  (not (object (is-a SIGN) (node_id ?node) (id "ssf-file-other-error")))
  (test (not (member$ compat-base-2016.0 ?ssf-layer)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (severity 70) (source ?obj)
                 (state observed) (value TRUE)
                 (id "ssf-layer-compat-base-2016.0")
                 (remedy "ssf-layer-dependency-remedy")
                 (args (create$ "compat-base-2016.0"))))

