; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule storage-compute
  "Checks the Intel(R) Scalable System Framework required minimum for compute node storage.
   The compute node must have at least 16 GiB of RAM and access to
   at least 80 GiB of persistent storage. Login nodes should have
   at least 200 GiB of persistent storage. "
  (object (is-a CONFIG) (name [config])
          (clck-checks $? storage $?))
  ?obj <- (object (is-a STORAGE) (node_id ?node)
                  (blocks_local ?blocks_local)
                  (blocks_network ?blocks_network))
  (object (is-a NODE) (node_id ?node) (architecture x86_64) (role $?role))
  (test (or (member$ compute ?role) (member$ enhanced ?role)))
  (test (not (or (member$ head ?role) (member$ storage ?role))))
  (test (< (+ ?blocks_local ?blocks_network) 85899345920))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "storage-compute")
                 (args (create$ (+ ?blocks_local ?blocks_network)
                                85899345920 "compat-base" ))))

