; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule storage-free-space
   (object (is-a CONFIG) (name [config])
           (clck-checks $? storage $?) (storage-max-used-pct ?storage-max-used-pct))
   ?obj <- (object (is-a STORAGE_MOUNT_POINT)
                  (node_id ?node)
                  (mount_point ?mount_point)
                  (blocks_used ?blocks_used)
                  (blocks_total ?blocks_total))
  (object (is-a NODE) (node_id ?node) (architecture x86_64) (role $?role))
  (test (>= (* 100 (/ ?blocks_used ?blocks_total)) ?storage-max-used-pct))
  =>
  (bind ?x (* 100 (/ ?blocks_used ?blocks_total)))
  (bind ?sigma (/ (- 100 ?storage-max-used-pct) 3))
  (bind ?severity (* 90 (gaussian ?x 100 ?sigma)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 80) (severity ?severity)
                  (state observed) (source ?obj) (value TRUE)
                  (id "storage-free-space") (sub-id (str-cat ?mount_point))
                  (args (create$ ?mount_point ?x (- ?blocks_total ?blocks_used)))))


