; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule storage-sdvis-single-node-2018.0
  "Checks for a minimum of 4 tebibytes of persistent storage, as required by
   the Intel HPC Platform Specification layer sdvis-sdvis-single-node-2018.0."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? storage $?))
  ?obj <- (object (is-a STORAGE) (node_id ?node)
                  (blocks_local ?blocks_local)
                  (blocks_network ?blocks_network))
  (object (is-a NODE) (node_id ?node) (architecture x86_64) (role $?role))
  (test (< (+ ?blocks_local ?blocks_network) 4398046511104))
  =>
  (bind ?storage (+ ?blocks_local ?blocks_network))
  (bind ?pval (perform_byte_conversion ?storage 1 0))
  (bind ?pvalr (perform_byte_conversion 4398046511104 1 0))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (severity 80)
                 (state observed) (source ?obj) (value TRUE)
                 (id "storage-sdvis-single-node-2018.0")
                  ; the reference value is not used in the message, due
                  ; to translation limitation, if the value is updated,
                  ; it will be needed to be update in xmc file.
                 (args (create$ ?pval ?pvalr))))

