; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule stream-data-is-too-old
  "Similar to latest-dgemm-data-is-too-old, just looks for out dated
   data"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? stream $?) (data-age-threshold ?age-threshold))
  ?obj <-(object (is-a STREAM) (latest-timestamp TRUE) (node_id ?node)
                 (timestamp ?t))
  (object (is-a NODE) (node_id ?node))
  (not (object (is-a SIGN) (node_id ?node) (id "stream-data-is-too-old")))
  (test (< ?t (- (now) ?age-threshold)))
  =>
  (bind ?age (round (- (now) ?t)))
  (make-instance of BOOLEAN_SIGN (node_id ?node) (confidence 90) (severity 25)
                 (state observed) (value TRUE) (source ?obj)
                 (id "stream-data-is-too-old")
                 (args (create$ ?age ?age-threshold))))

