; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule stream-no-runtimes
  "Look for cases where STREAM failed because libiomp5 could not be found."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? stream $?))
  ?obj <- (object (is-a STREAM) (node_id ?hostname) (latest-timestamp TRUE)
                  (stderr ?err))
  (object (is-a NODE) (node_id ?hostname))
  (test (str-index "libiomp5.so: cannot open shared object file: No such file or directory" ?err))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 20) (severity 25)
                 (state observed) (value TRUE) (source ?obj)
                 (id "stream-no-runtimes")))

