; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule ethernet_device_not_1gb
  "No 1Gb ethernet device is found on the node."
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? sys_devices $?))
  ?obj <-(object (is-a SYS_DEVICES) (node_id ?node)
                        (device_types $?d_t&: (member$ ethernet ?d_t))
                        (device_idxs $? ?didx $?))
  (test (and (not (>= (send ?obj get-device-speed-by-idx ?didx) 10000))
             (or (eq (str-compare (send ?obj get-device-state-by-idx ?didx) dorment) 0)
                 (eq (str-compare (send ?obj get-device-state-by-idx ?didx) up) 0))
             (eq (str-compare (send ?obj get-device-type-by-idx ?didx) ethernet) 0)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (confidence 70) (severity 90)
          (state observed) (value TRUE)
          (id "ethernet_device_not_1gb")
          (remedy "ethernet_device_not_1gb-remedy"))
)
