; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule firmware-not-uniform
  "Checks for firmware uniformity across node of the same type"
  (object (is-a CONFIG) (name [config])
          (clck-checks $? sys_devices $?))
  (analyze-extension-done)
  ?obj <- (object (is-a SYS_DEVICES)
                  (device_idxs $? ?didx $?)
                  (node_id ?node))
  (test (neq (str-compare (send ?obj get-device-fw-by-idx ?didx) "Unknown") 0))
  (test (eq (str-compare (send ?obj get-device-type-by-idx ?didx) "nvme") 0))
  (test (< (send ?obj parse-uniformity ?didx) 1.0))
  =>
  (bind ?type (send ?obj get-device-type-by-idx ?didx))
  (bind ?fraction
    (- 1 (send ?obj fraction
            (send ?obj uniformity-key ?type)
            (send ?obj get-device-fw-by-idx ?didx))))

  (bind ?percent (* 100 ?fraction))

  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence ?percent) (severity 25)
                 (state observed) (source ?obj) (value TRUE)
                 (id "firmware-not-uniform")
                 (args (create$ (- 100 ?percent)
                          (send ?obj get-device-fw-by-idx ?didx)
                          (send ?obj get-device-type-by-idx ?didx)))
  )
)
