; Copyright 2018-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule nvme_device_not_p4500
  "No P4500 NVMe device is found on the node."
  (analyze-extension-done)
  (object (is-a CONFIG) (name [config])
          (clck-checks $? sys_devices $?))
  ?obj <-(object (is-a SYS_DEVICES) (node_id ?node)
                        (role $?role&:(member$ application ?role))
                        (device_types $?d_t&:(member$ nvme ?d_t))
                        (device_idxs $? ?didx $?))
  (test (and (not (eq (send ?obj get-device-id-by-idx ?didx) 0x0a54))
             (eq (str-compare (send ?obj get-device-type-by-idx ?didx) nvme) 0)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
          (confidence 70) (severity 20)
          (state observed) (value TRUE)
          (id "nvme_device_not_p4500")
          (remedy "nvme_device_not_p4500-remedy"))
)
