; Copyright 2006-2019 Intel Corporation
;
; This software and the related documents are Intel copyrighted materials, and
; your use of them is governed by the express license under which they were
; provided to you (License). Unless the License provides otherwise, you may
; not use, modify, copy, publish, distribute, disclose, or transmit this
; software or the related documents without Intel's prior written permission.
;
; This software and the related documents are provided as is, with no express
; or implied warranties, other than those that are expressly stated in the
; License.

(defrule tcl-not-minimum
   "Check if the tcl version is less than 8.5."
  (object (is-a CONFIG) (name [config])
          (clck-checks $? tcl $?))
  ?obj <- (object (is-a TCL) (latest-timestamp TRUE) (node_id ?hostname)
                  (version ?ver&:(!= (str-length ?ver) 0)))
  (object (is-a NODE) (node_id ?hostname))
  (test (< (vercmp ?ver "8.5") 0))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 90) (severity 70) (source ?obj)
                 (state observed) (value TRUE) (id "tcl-not-minimum")
                 (args (create$ ?ver "8.5"))))

