#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

if [[ ! -z $CLCK_CONNECT_WITH_MPI ]] ; then
  # the file needs to be sorted in natural alphanumeric order
  \sort ${CLCK_DP_NODEFILE} --version-sort -o ${CLCK_DP_NODEFILE}
  exec mpirun -rr -ordered-output -prepend-pattern '%h: ' -f ${CLCK_DP_NODEFILE} hostname -i
else # default to pdsh
  exec $(dirname $0)/../../../libexec/intel64/pdsh -t 30 -f 64 -w ^${CLCK_DP_NODEFILE} hostname -i
fi
