#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

if [ -x /usr/sbin/ethtool ]; then
  ETHTOOL=/usr/sbin/ethtool
elif [ -x /sbin/ethtool ]; then
  ETHTOOL=/sbin/ethtool
else
  # maybe it's in PATH? Hope for the best.
  ETHTOOL=ethtool
fi

interfaces=`/sbin/ip addr | grep -v LOOPBACK | grep "^[0-9]" | awk -F': ' '{print $2}'`

for i in $interfaces ; do
  echo "interface: $i"
  $ETHTOOL -c $i
done
