#!/bin/bash
# Copyright 2016-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

. $(dirname $0)/../../functions
if [ ${UID} != "0" ]; then
    _stderr "Root access is required for dmidecode to run properly."
    exit 1
fi

function main {
# Memory
\dmidecode -t 17 |\grep -e Handle -A 16 |\grep -e Handle -e Manufacturer -e "Serial" |\grep -v -e Array -e Error |\sed -e 's/^[[:space:]]*//' |tr '\n' ' ' |\sed 's/Handle/\n/g' |\sed -e 's/^[[:space:]]*//'

#processor
\dmidecode -t 4 |\grep -e Handle -e ID -e Version |\grep -v -e Cache |\sed -e 's/^[[:space:]]*//' |\tr '\n' ' ' |\sed 's/Handle/\n/g'

#BIOS
\dmidecode -t 0 |\grep -e Handle -e "BIOS Information" -e Version |\sed -e 's/^[[:space:]]*//' |\tr '\n' ' ' |\sed 's/Handle/\n/g' |\sed -e 's/^[[:space:]]*//'

#Base Board
\dmidecode -t 2 |\grep -e Handle -e "Base Board Information" -e Manufacturer -e "Product Name" -e Version |\grep -v -e Chassis -e Object |\sed -e 's/^[[:space:]]*//' |tr '\n' ' ' |\sed 's/Handle/\n/g' |\sed -e 's/^[[:space:]]*//'

echo
#pci
\lspci -m |\awk -F\" '{print $1=$1", " $4 " " $6 }' |\sed 's/ ,/,/g'
}

main $@ |\sort |\sed -e 's/^[[:space:]]*//' |\sed -e "1 d"

