#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

. $(dirname $0)/../../functions

get_tool_path "ibstat"

exit_code=70

if [[ "$CLCK_PROVIDER_IBSTAT_BINARY" -eq "" ]]; then
    BINARY=$tool_path
else
    BINARY="${CLCK_PROVIDER_IBSTAT_BINARY}"
fi

if [[ "$CLCK_PROVIDER_IBSTAT_LSPCI_PATH" == "" ]]; then
    get_tool_path "lspci"
    LSPCI_BIN="$tool_path"
else
    LCPSI_BIN="${CLCK_PROVIDER_IBSTAT_LSPCI_PATH}"
fi

dev_present_ec=72
lspci_out=`$LSPCI_BIN -k -D -v -nn -mm`
echo $lspci_out | \grep "Network controller" >& /dev/null
if [[ $? == 0 ]]; then
  dev_present_ec=0
if [[ $dev_present_ec -ne 0 ]]; then
  # try 2f41
  echo $lspci_out | \grep "InfiniBand controller" >& /dev/null
  if [[ $? == 0 ]]; then
    # found it, sane to go forward
    dev_present_ec=0
  fi
fi
fi

$BINARY
output=`$BINARY`
command_exit_code=$?
if [[ $command_exit_code -eq 0 ]]; then
  port_state_ec=70
  phy_state_ec=70
  # detect Active state
  echo $output | grep "State" | grep "Active" >& /dev/null
  if [[ $? -eq 0 ]]; then
    port_state_ec=0
  fi
  # detect LinkUp state
  echo $output| grep "Physical state" | grep "LinkUp" >& /dev/null
  if [[ $? -eq 0 ]]; then
    phy_state_ec=0
  fi
  if [[ $port_state_ec -eq 0 && $port_state_ec -eq 0 ]]; then
    exit_code=0
  fi
else
  exit $command_exit_code
fi

if [[ $exit_code -eq 0 ]]; then
  exit 0
else
  if [[ $dev_present_ec -eq 0 ]]; then
     if [[ $command_exit_code -eq 0 ]]; then
       exit $exit_code
     else
       exit $command_exit_code
     fi
  else
    exit $dev_present_ec
  fi
fi
