#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.
rpms=$(rpm -qa --qf "%{NAME} %{VERSION} %{RELEASE} %{ARCH}\n")
old_IFS=$IFS
lib="libdrm"
IFS=$'\n'
version=""

# Iterate through each rpm
for line in $rpms; do

  # Find all instances of libdrm
  if [[ "$line" == *"$lib"* ]]; then

    # Get the version
    IFS=$' '
    read -r -a array <<< "$line"
    for index in ${!array[@]}; do
      if [[ $index == 1 ]]; then
        curr_version=${array[index]}

        IFS=$'.'
        read -a parts <<< "$curr_version"
        IFS=$' '

        # Set initial version
        if [[ $version == "" ]]; then
          version="$curr_version"

        # Split the version
        else

          # Compare each part of the version
          IFS=$'.'
          read -a version_parts <<< "$version"
          IFS=$' '
          for i in ${!parts[@]}; do
            if (( ${parts[i]} > ${version_parts[i]} )); then
              version=$curr_version
              break
            fi
            if (( ${parts[i]} < ${version_parts[i]} )); then
              # Current found version is higher
              break
            fi
          done
        fi
      fi

    done
    IFS=$'\n'
  fi
done
echo $version

rpms=$(rpm -qa)

# Iterate through each rpm
for line in $rpms; do

  # Find libdrm rpm with found version
  if [[ "$line" == *"$lib"* && "$line" == *"$version"* ]]; then
    rpm -ql $line
  fi
done

IFS=$old_IFS
