#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

function check_shell() {
    name=$1
    path=/bin/$1

    echo -n $1 " "

    # First, we test existence
    test -x $path
    echo -n $? " "

    # We create a temporary file in which to create a script
    TEMPF=$(mktemp)

    # Create the script
    echo echo HelloWorld > $TEMPF

    # Attempt to run the script with the shell
    RESULT=$($path $TEMPF 2>/dev/null)

    # Add it to STDOUT
    echo -n Output:$RESULT

    # Remove our temporary file
    rm $TEMPF

    # Wrap up this shell details with a newline
    echo
}

check_shell bash
check_shell tcsh
check_shell sh
check_shell ksh
check_shell csh
