#!/bin/bash
# Copyright 2015-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.

function uname_sh() {
    name=$1
    arg=$2

    out=`uname ${arg} 2> /dev/null`
    if [ $? == 0 ]; then
        echo "${name}: ${out}"
    else
        echo >&2 "${name}: unsupported"
    fi
}

uname_sh "kernel-name" "-s"
uname_sh "nodename" "-n"
uname_sh "kernel-release" "-r"
uname_sh "kernel-version" "-v"
uname_sh "machine" "-m"
uname_sh "processor" "-p"
uname_sh "hardware-platform" "-i"
uname_sh "operating-system" "-o"
uname_sh "all" "-a"
