#!/bin/bash
# Copyright 2018-2019 Intel Corporation
#
# This software and the related documents are Intel copyrighted materials, and
# your use of them is governed by the express license under which they were
# provided to you (License). Unless the License provides otherwise, you may
# not use, modify, copy, publish, distribute, disclose, or transmit this
# software or the related documents without Intel's prior written permission.
#
# This software and the related documents are provided as is, with no express
# or implied warranties, other than those that are expressly stated in the
# License.
. $(dirname $0)/../../functions
lib_detection_exit_code=70
if [[ ! -z $LD_LIBRARY_PATH ]]; then
  # get the list of paths
  path_list=${LD_LIBRARY_PATH//:/ }
  for path in $path_list
  do
    lib_path=`find $path -name "libvtkAddon.so" -printf '%h/../' 2>/dev/null`
    if [[ ! -z "$lib_path" ]]; then
      #lib detect
      lib_detection_exit_code=$ec
      break
    fi
  done
else
  _stderr "LD_LIBRARY_PATH environment variable not defined or null"
  lib_detection_exit_code=71
fi
if [[ ! -z "$lib_path" ]]; then
  vtk_version=$(grep -rE "^#define VTK_VERSION" $lib_path | sed -n 's/.*:#define VTK_VERSION \"\(.*\)\"/\1/p')
  if [[ ! -z "$vtk_version" ]]; then
    echo "VTK version:" $vtk_version
  fi
fi
exit $lib_detection_exit_code
